#!/usr/bin/env python
# -*- coding: utf-8 -*-

#librerias estandar
from tkinter import *
from tkinter import ttk, font
import tkinter as tk
from tkinter import messagebox as mb
import matplotlib.pyplot as plt
from matplotlib.figure import Figure
from matplotlib.backends.backend_tkagg import FigureCanvasTkAgg
import numpy as np
import skrt as rf #para leer fichero de alvaro
from skrf import Network, Frequency
import control #para pasar s-parameters a dB
import scipy
from scipy.signal import find_peaks #para encontrar los picos de las graficas
from tkinter import filedialog #para poder leer ficheros en otro directorio
import os
from pylab import *
from skrf.data import ring_slot
from sklearn.neighbors import NearestNeighbors
from tkinter import messagebox
from PIL import ImageTk, Image
import tkinter.font as tkfont
import math
from matplotlib.collections import LineCollection
from scipy import signal
from scipy.fft import fft, fftshift
import pandas
from mpl_toolkits.mplot3d.art3d import Poly3DCollection
from mpl_toolkits import mplot3d
from mpl_toolkits.mplot3d import Axes3D
import matplotlib.gridspec as gridspec
from scipy.signal import savgol_filter, group_delay, hilbert
import stl
from stl import mesh

#librerias propias
from sistemaMicrobio import sistemaMicrobio
# from pythoh_plot_3d import STPLOT

#creamos el objeto sysMicrobio que contiene los metodos para el VNA y la comunicacion serie
sysMicrobio = sistemaMicrobio()

class guiMain():
    """Clase de la interfaz general del proyecto MicroBio"""
    
   

    #en la inicializacion se crea la interfaz principal (raiz)
    def __init__(self):
        self.raiz = Tk()
        self.raiz.title("Interfaz Microbio")
               
        self.raiz.resizable(width=False,height=False) # se puede poner (0,0) o (1,1) si es resizable
        self.raiz.geometry('1280x1024')
        self.raiz.anchor("nw")
        self.raiz.configure(bg = 'beige')
        fuente = font.Font(family="Arial", weight='bold', size=30)
        style=ttk.Style()
        style.configure('C.TButton', font=("Roboto Cn", 18))
        style.configure('B.TButton', font=("Roboto Cn", 14))
    
        #self.marco = ttk.Frame(self.raiz, borderwidth=2, relief="raised", padding=(10,10))
                               
        # Labels
        logoUmh = PhotoImage(file='C:/Workspace/imagenes/logo_umh_2.gif')
        logoAVI = PhotoImage(file='C:/Workspace/imagenes/logo_avi_2.gif')
        #logoUmh = PhotoImage(file='/Volumes/GoogleDrive/Mi unidad/sandbox/Python/imagen/logo_umh_2.gif')
        #logoAVI = PhotoImage(file='/Volumes/GoogleDrive/Mi unidad/sandbox/Python/imagen/logo_avi_2.gif')

        self.etiq0 = ttk.Label(self.raiz, text = "INTERFAZ PRINCIPAL", font=fuente, padding=(5,5))
        self.imagen1 = ttk.Label(self.raiz, image = logoAVI, anchor="center")
        self.imagen2 = ttk.Label(self.raiz, image = logoUmh, anchor="center")
        self.etiq1 = ttk.Label(self.raiz, text="Arduino:", font=fuente, padding=(5,5))
        self.etiq2 = ttk.Label(self.raiz, text="VNA:", font=fuente, padding=(5,5))
        self.separ1 = ttk.Separator(self.raiz, orient='horizontal')

        # textboxes
        
        self.okArduino = StringVar()
        self.okVNA = StringVar() 
        self.ctext1 = tk.Text(self.raiz, width=5, height=2)      
        #self.ctext1 = ttk.Entry(self.raiz, textvariable=self.okArduino, width=10)
        self.ctext2 = tk.Text(self.raiz, width=5, height=2)
        #self.ctext2 = ttk.Entry(self.raiz, textvariable=self.okVNA, width=10)
        def quit():
            sys.exit()
        # buttons
        self.boton1 = ttk.Button(self.raiz, text="Iniciar Sistema", style='C.TButton', padding=(5,5), command=self.iniciar)
        self.boton2 = ttk.Button(self.raiz, text="Medir Resonadores", style='C.TButton',padding=(5,5), command=self.guiMedirResonadores)
        self.boton3 = ttk.Button(self.raiz, text="Medir VNA",style='C.TButton', padding=(5,5), command=self.guiMedirVNA)
        self.boton4 = ttk.Button(self.raiz, text="Visualizar Datos",style='C.TButton', padding=(5,5), command=self.guiVisualizarDatos)
        self.boton5 = ttk.Button(self.raiz, text="Salir",style='B.TButton', padding=(5,5), command=quit)
        
        # grid columns=5 rows=7.
        self.raiz.columnconfigure(0, weight=2)
        self.raiz.columnconfigure(1, weight=1)
        self.raiz.columnconfigure(2, weight=1)
        self.raiz.columnconfigure(3, weight=1)
        self.raiz.columnconfigure(4, weight=2)
        self.raiz.rowconfigure(0, weight=3)
        self.raiz.rowconfigure(1, weight=1)
        self.raiz.rowconfigure(2, weight=2)
        self.raiz.rowconfigure(3, weight=1)
        self.raiz.rowconfigure(4, weight=1)
        self.raiz.rowconfigure(5, weight=1)
        self.raiz.rowconfigure(6, weight=2)

        ''' el grid interior '''
        # self.imagen1.grid(column=0, row=0, padx=5, pady=5)
        self.etiq0.grid(column=1, row=0, columnspan=3)
        # self.imagen2.grid(column=4, row=0, padx=5, pady=5)
        self.separ1.grid(column=0, row=1, columnspan=5, padx=5, pady=5)
        self.boton1.grid(column=0, row=2, columnspan=2, padx=5, pady=5, sticky="nsew")
        self.etiq1.grid(column=0, row=3)
        self.ctext1.grid(column=1, row=3)
        self.boton2.grid(column=3, row=3, columnspan=2, sticky="nsew")
        self.etiq2.grid(column=0, row=4)
        self.ctext2.grid(column=1, row=4)
        self.boton3.grid(column=3, row=4, columnspan=2, sticky="nsew")
        #self.separ1.grid(column=0, row=5, columnspan=5, padx=5, pady=5)
        self.boton4.grid(column=3, row=5, columnspan=2, sticky="nsew")
        self.boton5.grid(column=4, row=6)

        #establece el foco y control loop
        self.boton1.focus_set()
        self.raiz.mainloop()
    
    def iniciar(self):
        #texto_ok = "OK"
        #TO-DO ver como se llama a un metodo con parametros. No esta llegando a iniciarArduino
        ack = sysMicrobio.iniciarArduino('phantom')
        #ack = 0
        #fuente2 = font.Font(weight='bold', size=20)
        #si los resonadores son ok
        if ack == 0:

            self.ctext1.insert("1.0", "OK")
            self.ctext1.tag_add("here", "1.0", "1.2")
            self.ctext1.tag_config("here", foreground="green")
        else:
            self.ctext1.insert("1.0", "WRONG")
            self.ctext1.tag_add("here", "1.0", "1.5")
            self.ctext1.tag_config("here", foreground="red")

        
        #si el VNA es ok
        self.ctext2.insert("1.0", "WRONG")
        self.ctext2.tag_add("here", "1.0", "1.5")
        self.ctext2.tag_config("here", foreground="red")
        
        print("dentro de iniciar")
        mb.showinfo("Informacion", "Sistema correctamente iniciado")
    
    def guiMedirResonadores(self):
        print("Midiendo resonadores....")
        ''' Construye una ventana de diálogo '''
        self.guiResonadores.anchor("nw")
        self.guiResonadores = Toplevel()
        self.guiResonadores.geometry('1280x1024')
        self.guiResonadores.configure(bg = 'grey')
        self.guiResonadores.resizable(0,0)
        self.guiResonadores.title("Medidas de los resonadores")
       #widgets
        self.msgResonadores = StringVar()

        # imgResonadores = PhotoImage(file='C:/Workspace/imagenes/resonadores.gif')
        #imgResonadores = PhotoImage(file='/Volumes/GoogleDrive/Mi unidad/sandbox/Python/imagen/resonadores.gif')
        # self.resImagen1 = ttk.Label(self.guiResonadores, image = imgResonadores, anchor="center")
        self.resBoton1 = ttk.Button(self.guiResonadores, text='Medir Resonador 1', command=self.medirResonador1)
        self.resBoton2 = ttk.Button(self.guiResonadores, text='Medir Resonador 2', command=self.medirResonador(2))
        self.resBoton3 = ttk.Button(self.guiResonadores, text='Medir Resonador 3', command=self.medirResonador(3))
        self.resBoton4 = ttk.Button(self.guiResonadores, text='Medir Resonador 4', command=self.medirResonador(4))
        self.ctextResonadores = tk.Text(self.guiResonadores, height=2) 
        self.ctextResonadores.insert("1.0", "Pulse el boton del resonador. Coloque el MUT...")
        self.resBotonSalir = ttk.Button(self.guiResonadores, text='Cerrar', command=self.guiResonadores.destroy) 
        #grid
        # self.resImagen1.grid(column=2, row=1, columnspan=2, rowspan=4, padx=5, pady=5)
        self.resBoton1.grid(column=0, row=1, columnspan=2, padx=5, pady=5, sticky="nsew")
        self.resBoton2.grid(column=0, row=2, columnspan=2, padx=5, pady=5, sticky="nsew")
        self.resBoton3.grid(column=0, row=3, columnspan=2, padx=5, pady=5, sticky="nsew")
        self.resBoton4.grid(column=0, row=4, columnspan=2, padx=5, pady=5, sticky="nsew")
        self.ctextResonadores.grid(column=1, row=6, columnspan=3, padx=25, pady=15)
        self.resBotonSalir.grid(column=3, row=7, columnspan=2)

        self.guiResonadores.transient(master=self.raiz)
        self.guiResonadores.grab_set()
        self.raiz.wait_window(self.guiResonadores)

        #self.resBoton1.focus_set()
        #TO_DO cambiarlos nombres de los widgets. No repetir.
        self.guiResonadores.mainloop()
       

    def medirResonador(self,numero):
        ok = sysMicrobio.medirResonador(numero)
        #self.guiResonadores.ctextResonadores.insert("1.0", "vamos a medir..")
        print(ok)

    def medirResonador1(self):
        ok = sysMicrobio.medirResonador1()
        self.guiResonadores.ctextResonadores.insert("1.0", "vamos a medir..")
        print(ok)

    def guiVisualizarDatos(self):
        ''' Construye una ventana de diálogo '''
        self.raiz.withdraw()
        self.guiDatos=Toplevel()
        self.guiDatos.geometry('1280x1024')
        self.guiDatos.resizable(0,0)
        self.guiDatos.configure(bg="beige")
        self.guiDatos.title("Visualizar Datos")
        fuentetitulo = font.Font(family="Helvetica", weight='bold', size=30, slant="roman")
        self.guiDatos.anchor("nw")
        style=ttk.Style()
        style.configure('C.TButton', font=("Roboto Cn", 18))
        style.configure('B.TButton', font=("Roboto Cn", 14))
        
        self.guiDatos.columnconfigure(0, weight=2)
        self.guiDatos.rowconfigure(0, weight=2)
        self.guiDatos.rowconfigure(1, weight=1)
        self.guiDatos.rowconfigure(2, weight=1)
        self.guiDatos.rowconfigure(3, weight=1)
        self.guiDatos.rowconfigure(4, weight=1)
        self.guiDatos.rowconfigure(5, weight=1)
        self.guiDatos.rowconfigure(6,weight=1)
        self.guiDatos.rowconfigure(7, weight=2)
        
        #Widgets
        
        self.etiqueta=ttk.Label(self.guiDatos, text="QUE DESEA VISUALIZAR?" ,font=fuentetitulo)
        self.boton2=ttk.Button(self.guiDatos, text="Importar Ficheros s2p Resonadores", style='C.TButton',command=self.leerfichero)
        self.boton3=ttk.Button(self.guiDatos, text="Importar Ficheros s2p Antenas",style='C.TButton',command=self.leerantenas)
        self.boton6=ttk.Button(self.guiDatos, text="Resultados Dominio Tiempo",style='C.TButton', command=self.señalestemporales)
        self.boton7=ttk.Button(self.guiDatos, text="Resultados Método Directo",style='C.TButton', command=self.ifft)
        self.boton8=ttk.Button(self.guiDatos, text="DAS/DMAS",style='C.TButton', command=self.das)
        self.boton9=ttk.Button(self.guiDatos, text="IMAGEN 3D",style='C.TButton', command=self.plot3d)
        self.botonSalir=ttk.Button(self.guiDatos, text='Cerrar',style='B.TButton',command=self.goback1)
        

        #Grid
        self.etiqueta.grid(column=0, row=0, padx=5, pady=5)
        self.etiqueta.configure(anchor=CENTER)
        self.boton2.grid(column=0, row=1, padx=5, pady=5, sticky="nsew")
        self.boton3.grid(column=0, row=2, padx=5, pady=5, sticky="nsew")
        self.boton6.grid(column=0, row=3, padx=5, pady=5, sticky="nsew")
        self.boton7.grid(column=0, row=4, padx=5, pady=5, sticky="nsew")
        self.boton8.grid(column=0, row=5, padx=5, pady=5, sticky="nsew")
        self.boton9.grid(column=0, row=6, padx=5, pady=5, sticky="nsew")
        self.botonSalir.grid(column=0, row=7, sticky="e")
        
    def leerantenas(self):
        global time_i
        global S_nc_i_tiempo
        global S_c_i_tiempo
        global temporal_i
        
        mama_mesh=mesh.Mesh.from_file('C:/Workspace/recipientemamasinagujeros.stl')
        vertices=np.around(np.unique(mama_mesh.vectors.reshape([int(mama_mesh.vectors.size/3), 3]), axis=0),2)
        normals=mama_mesh.normals
        faces=mama_mesh.areas
        
        
        c_v = 299792458;
        er1 = 1; #de aqui se modifica la Er del material
        er2 = 1;
        speed1 = c_v/math.sqrt(er1);  
        speed2 = c_v/math.sqrt(er2); 
        
        radio_antena=np.fix(max(vertices[:,0]))/1000
        gap=0.005
        espesor=2*(radio_antena-gap)
        
        analisis_temporal=0
        analisis=1
        plot_S21=0
        estimacion=0
        view_3d=1
        view_3d_level=1
        max_rango_plot=50
        
        if view_3d==1:
            vector_plot=[0,1,8,7,4,5,12,3,2,11,9,6,15,13,14,10]
            level_1=vector_plot[0:8]
            level_2=vector_plot[9:14]
            level_3=vector_plot[15:16]
        else:
            vector_plot=[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15]
        
        
        messagebox.showinfo(message="Elige las medidas de referencia sin cabeza")
        file=filedialog.askopenfilenames()
        messagebox.showinfo(message="Elige las medidas de las antenas con cabeza")
        file1=filedialog.askopenfilenames()
        
        S11_nc=np.zeros([16,5001])
        S21_nc=np.zeros([16,5001])
        S11_c=np.zeros([16,5001])
        S21_c=np.zeros([16,5001])
        
        for n in range (0, len(file)):
            hs_nc=Network(file[n])
            if n<=4 :
        
                S11_nc[n,:]=np.squeeze(hs_nc.s[:,0,0])
                S11_nc[n+4,:]=np.squeeze(hs_nc.s[:,1,1])
                S21_nc[n,:]=np.squeeze(hs_nc.s[:,0,1])
                S21_nc[n+4,:]=np.squeeze(hs_nc.s[:,1,0])
            
            
            else:
                S11_nc[n+4,:]=np.squeeze(hs_nc.s[:,0,0])
                S11_nc[n+8,:]=np.squeeze(hs_nc.s[:,1,1])
                S21_nc[n+4,:]=np.squeeze(hs_nc.s[:,0,1])
                S21_nc[n+8,:]=np.squeeze(hs_nc.s[:,1,0])
           
        for n in range (0, len(file1)):
            hs_c=Network(file1[n])
            if n<=4 :
                S11_c[n,:]=np.squeeze(hs_c.s[:,0,0])
                S11_c[n+4,:]=np.squeeze(hs_c.s[:,1,1])
                S21_c[n,:]=np.squeeze(hs_c.s[:,0,1])
                S21_c[n+4,:]=np.squeeze(hs_c.s[:,1,0])
            
            else:
                S11_c[n+4,:]=np.squeeze(hs_c.s[:,0,0])
                S11_c[n+8,:]=np.squeeze(hs_c.s[:,1,1])
                S21_c[n+4,:]=np.squeeze(hs_c.s[:,0,1])
                S21_c[n+8,:]=np.squeeze(hs_c.s[:,1,0])
            
        
            nElements, ifft_val=np.shape(S11_nc)
            f=hs_nc.f
        
        # #PROCESADO DE DATOS NO INTERPOLACION
        Fs=12e9
        # Window=signal.windows.bohman(ifft_val)
        SortofWin='bohman'
        Window=signal.get_window(SortofWin, ifft_val)
        r_t=(len(f)-1)/(max(f)-min(f))
        ss=r_t/(len(f)-1)
        time=np.linspace(-(len(f)-1)/2*ss, (len(f)-1)/2*ss, num=len(f))
        t_plot=np.linspace(0, max(time), num=len(f))
        dist_plot=(t_plot*speed1)/2
        
        
        S11_c_vent=np.zeros((nElements, ifft_val))
        S11_nc_vent=np.zeros((nElements, ifft_val))
        S21_c_vent=np.zeros((nElements, ifft_val))
        S21_nc_vent=np.zeros((nElements, ifft_val))
        
        
        for k in vector_plot:
            S11_c_vent[k,:]=np.squeeze(S11_c[k,:]*Window)
            S11_nc_vent[k,:]=np.squeeze(S11_nc[k,:]*Window)
            S21_c_vent[k,:]=np.squeeze(S21_c[k,:]*Window)
            S21_nc_vent[k,:]=np.squeeze(S21_nc[k,:]*Window)
            
        S11_c_tiempo=np.zeros((nElements, ifft_val))
        S11_nc_tiempo=np.zeros((nElements, ifft_val))
        S21_c_tiempo=np.zeros((nElements, ifft_val))
        S21_nc_tiempo=np.zeros((nElements, ifft_val))
        temporal11=np.zeros((nElements, ifft_val))
        temporal21=np.zeros((nElements, ifft_val))
        
        for k in vector_plot:
            S11_c_tiempo[k,:]=np.real(np.fft.ifft(S11_c_vent[k,:]))
            S11_nc_tiempo[k,:]=np.real(np.fft.ifft(S11_nc_vent[k,:]))
            temporal11[k,:]=(S11_c_tiempo[k,:]-S21_nc_tiempo[k,:])
            
            S21_c_tiempo[k,:]=np.real(np.fft.ifft(S21_c_vent[k,:]))
            S21_nc_tiempo[k,:]=np.real(np.fft.ifft(S21_nc_vent[k,:]))
            temporal21[k,:]=(S21_c_tiempo[k,:])- (S21_nc_tiempo[k,:])
             
            medida11=np.absolute(temporal11)/np.amax(np.amax(np.absolute(temporal11)))
            medida12=np.absolute(temporal21)/np.amax(np.amax(np.absolute(temporal21)))
   
            S11_nc_tiempo=np.fft.ifftshift(S11_nc_tiempo)
            S11_c_tiempo=np.fft.ifftshift(S11_c_tiempo)
            medida11=np.fft.ifftshift(medida11)
            temporal11=np.fft.ifftshift(temporal11)
            S21_nc_tiempo=np.fft.ifftshift(S21_nc_tiempo)
            S21_c_tiempo=np.fft.ifftshift(S21_c_tiempo)
            medida12=np.fft.ifftshift(medida12)
            temporal21=np.fft.ifftshift(temporal21)
                
        
        #DATOS DE INTERPOLACION
        Fsi=12e9
        DF=f[1]-f[0]
        F_Axis_i=np.arange(0,Fsi-DF,DF)
        ifft_val_i=len(F_Axis_i)  
        r_t_i=(len(F_Axis_i)-1)/(max(F_Axis_i)-min(F_Axis_i))
        ss_i=r_t_i/(len(F_Axis_i)-1)
        time_i=np.linspace(-(len(F_Axis_i)-1)/2*ss_i,(len(F_Axis_i)-1)/2*ss_i, num=len(F_Axis_i))
        t_plot_i=np.linspace(0, max(time_i), num=len(F_Axis_i))
        dist_plot_i=t_plot_i*speed1 / 2
        f_plot_i=np.hstack((-1*np.arange(Fsi/2,0,-DF), np.arange(DF,(Fsi-DF)/2,DF)))
        
        n1=np.amax(np.nonzero(F_Axis_i<=f[0]))             
        S_nc_i=np.zeros((nElements, ifft_val_i))
        S_c_i=np.zeros((nElements, ifft_val_i))
        window_i=np.zeros((1, ifft_val_i))
        
        
        # window=np.reshape(Window, (1,5001))
        window_i[0,n1:n1+len(f)]=Window
        window_i[np.int(ifft_val_i/2)+2:-1]=np.conj(np.fliplr(window_i[1:np.int(ifft_val_i/2)]))
        
        
        for n in vector_plot:
            S_nc_i[n,np.arange(n1,n1+len(f))]=S11_nc[n,:]
            S_nc_i[n,np.arange(n1+len(f),np.int(ifft_val_i/2)+1)]=S11_nc[n,-1]
            S_nc_i[n,np.arange(0,n1)]=S_nc_i[n,n1+1]
            S_nc_i[n,int(ifft_val_i/2):-1]=np.conj(S_nc_i[n,1:int(ifft_val_i/2)])
            
            S_c_i[n,np.arange(n1,n1+len(f))]=S11_c[n,:]
            S_c_i[n,np.arange(n1+len(f),int(ifft_val_i/2)+1)]=S11_c[n,-1]
            S_c_i[n,np.arange(0,n1)]=S_c_i[n,n1+1]
            S_c_i[n,int(ifft_val_i/2):-1]=np.conj(S_c_i[n,1:int(ifft_val_i/2)])
            
        S_c_i_vent=np.zeros((nElements, ifft_val_i))
        S_nc_i_vent=np.zeros((nElements, ifft_val_i))
        
        for k in vector_plot:
            S_c_i_vent[k,:]= np.multiply(S_c_i[k,:],window_i)
            S_nc_i_vent[k,:]= np.multiply(S_nc_i[k,:],window_i)
            
        
        S_c_i_tiempo=np.zeros((nElements, ifft_val_i))
        S_nc_i_tiempo=np.zeros((nElements, ifft_val_i))
        temporal_i=np.zeros((nElements, ifft_val_i))
        medida_i=np.zeros((nElements,ifft_val_i))
        
        for k in vector_plot:
            S_c_i_tiempo[k,:]=np.real(np.fft.ifft(S_c_i_vent[k,:]))
            S_nc_i_tiempo[k,:]=np.real(np.fft.ifft(S_nc_i_vent[k,:]))
            temporal_i[k,:]=hilbert(S_c_i_tiempo[k,:]- S_nc_i_tiempo[k,:])
            
            media_i=np.absolute(temporal_i)/np.amax(np.amax(np.absolute(temporal_i)))
            
            S_nci_tiempo=np.fft.ifftshift(S_nc_i_tiempo)   
            S_ci_tiempo=np.fft.ifftshift(S_c_i_tiempo)
            media_i=np.fft.ifftshift(media_i)
            temporal_i=np.fft.ifftshift(temporal_i)
        
        time_i=np.reshape(time_i, (10016,1))
        S_nc_i_tiempo=np.reshape(S_nc_i_tiempo, (10016, 16))
        S_c_i_tiempo=np.reshape(S_c_i_tiempo, (10016, 16))
        temporal_i=np.reshape(temporal_i, (10016, 16))
        media_i=np.reshape(media_i, (10016, 16))
        
        #CREAMOS POSICIONES ANTENAS Y PESOS EN 3D
        # % una vez tenemos las señales en el tiempo pasamos a calcular los
        # % diferentes algoritmos de conformacion de imagen. creamos el entorno de
        # % trabajo y calculamos distancias y velocidades de onda desde las antenas a
        # % cada punto de la rejilla de interpolacion.
        # % Todas las distancias en (cm)
        
        if view_3d==0:
            MAX=256
            # [xPos,yPos]=polar2cart(np.arange(0,1-1/nElements,1/nElements)*2*math.pi, np.ones(1,nElements)*radio_antena)
            xPos=(np.ones(1,nElements)*radio_antena)*math.cos(np.arange(0,1-1/nElements,1/nElements))
            yPos=(np.ones(1,nElements)*radio_antena)*math.sin(np.arange(0,1-1/nElements,1/nElements))
            xPos=np.roll(xPos,5)
            yPos=np.roll(yPos,5)
            radio_interpol=radio_antena-gap
            r,theta=np.meshgrid(np.linspace(radio_interpol,-radio_interpol, num=MAX),np.linspace(0,2*math.pi,num=MAX))
            X=np.multiply(r,math.sin(theta))
            Y=np.multiply(r,math.sin(theta))
            X=X[:].getH()
            Y=Y[:].getH()
        else:
            antenas=pandas.read_csv('C:\Workspace\plot3dmatlab\posicion_antenas.csv')
            xPos=np.divide(antenas.X,1000)
            yPos=np.divide(antenas.Y,1000)
            zPos=np.divide(antenas.Z,1000)
            xPos=np.hstack(xPos)
            yPos=np.hstack(yPos)
            zPos=np.hstack(zPos)
        
        if view_3d_level==0:
            MAX=64
            minX_bd=np.divide(np.fix(np.minimum(vertices[:,0])),1000)
            maxX_bd=np.divide(np.fix(np.amax(vertices[:,0])),1000)
            minY_bd=np.divide(np.fix(np.minimum(vertices[:,2])),1000)
            maxY_bd=np.divide(np.fix(np.amax(vertices[:,2])),1000)
            minZ_bd=np.divide(np.fix(np.minimum(vertices[:,1])),1000)
            maxZ_bd=np.divide(np.fix(np.amax(vertices[:,1])),1000)
            
            x_axis=np.linspace(minX_bd,maxX_bd, num=MAX)
            y_axis=np.linspace(minY_bd,maxY_bd, num=MAX)
            z_axis=np.linspace(minZ_bd, maxZ_bd, num=MAX)
            
            axes_={x_axis,y_axis,z_axis}
            Xs,Ys,Zs=np.ndgrid(axes_)
            if (abs(Ys)<= 0.023) and (abs(Xs)<= 0.023):
                area_=Xs^2+Ys^2+Zs^2<=maxX_bd^2
            else:
                area_=Xs^2+Ys^2+Zs^2<=maxZ_bd^2
        
            ndim=3
            coords=np.cell(1,ndim)
        
            def fun(x):
                return np.arange(0,np.size(area_,x))
                domain_range=np.vectorize(np.arange(0,np.size(area_,x)),np.arange(0,ndim))
                array=np.arange(0,ndim)
                domain_range=fun(array)
                coords[:]=np.ndgrid(domain_range[:])
            def fun1(x):
                return x(area_)
            coords=fun1(coords)
            def fun2(n):
                return axes_[n](coords[n])
            coords=fun2(np.arange(0,2))
            def fun3(a):
                return a[:]
            coords=fun3(coords)
        
            points=pandas.str.cat(2, coords[:])
            X=points[:,0]
            Y=points[:,1]
            Z=points[:,2]
        
        else:
            MAX=256
            xPos_1=xPos[level_1]
            yPos_1=yPos[level_1]
            zPos_1=zPos[level_1]
            radio_interpol=np.amax(xPos_1)
            r,theta=np.meshgrid(np.linspace(radio_interpol,-radio_interpol, num=MAX),np.linspace(0,2*math.pi,num=MAX))
            X=np.multiply(r,np.sin(theta))
            Y=np.multiply(r,np.cos(theta))
            X_1=X.T.flatten()
            Y_1=Y.T.flatten()
            
            xPos_2=xPos[level_2]
            yPos_2=yPos[level_2]
            zPos_2=zPos[level_2]
            radio_interpol=np.amax(xPos_2)
            r,theta=np.meshgrid(np.linspace(radio_interpol,-radio_interpol, num=MAX),np.linspace(0,2*math.pi,num=MAX))
            X=np.multiply(r,np.sin(theta))
            Y=np.multiply(r,np.cos(theta))
            X_2=X.T.flatten()
            Y_2=Y.T.flatten()
            
        # Calculamos distancias y retardos
        
        if view_3d==0:
            Distance=np.zeros(nElements,len(X))
            delay=np.zeros(nElements,len(X))
            for k in vector_plot:
                for m in range(0,len(X)):
                    Distance[k,m]=math.sqrt((xPos[k]-X[m])^2 + (yPos[k]-Y[m])^2)
                    delay[k,m]=2*Distance[k,m]/speed1
        else:
            if view_3d_level==0:
                Distance=np.zeros(nElements,len(X))
                delay=np.zeros(nElements,len(X))
                for k in vector_plot:
                    for m in range(0,len(X)):
                        Distance[k,m]=math.sqrt((xPos[k]-X[m])^2 + (yPos[k]-Y[m])^2 + (zPos[k]-Z[m])^2)
                        delay[k,m]=2*Distance[k,m]/speed1
            else:
                Distance_1=np.zeros((len(level_1),len(X_1)))
                delay_1=np.zeros((len(level_1),len(X_1)))
                Distance_2=np.zeros((len(level_2),len(X_2)))
                delay_2=np.zeros((len(level_2),len(X_2)))
                while k==len(level_1):
                    for m in range(0,len(X_1)):
                        Distance_1[k,m]=math.sqrt((xPos_1[k]-X_1[m])^2 + (yPos_1[k]-Y_1[m])^2)
                        delay_1[k,m]=2*Distance_1[k,m]/speed1
                    for k in len(level_2):
                        for m in range(0,len(X_2)):
                            Distance_2[k,m]=math.sqrt((xPos_2[k]-X_2[m])^2 + (yPos_2[k]-Y_2[m])^2)
                            delay_2[k,m]=2*Distance_2[k,m]/speed1
        
    def goback1(self):
        self.guiDatos.withdraw()
        self.raiz.deiconify()
        
    def goback2(self):
        self.señalestemporales.withdraw()
        self.guiDatos.deiconify()
    
    def señalestemporales(self):
        self.guiDatos.withdraw()
        self.señalestemporales=Toplevel()
        self.señalestemporales.anchor("nw")
        self.señalestemporales.geometry('1280x1024')
        self.señalestemporales.resizable(0,0)
        # self.señalestemporales.configure(bg="black")
        self.señalestemporales.title('Resultados Dominio Tiempo')
        fuente = font.Font(weight='bold', size=16)
        style=ttk.Style()
        style.configure('B.TButton', font=("Roboto Cn", 14))
       
        
        #Widgets
        self.canvas=tk.Canvas(self.señalestemporales, bg='blue', width=1000, height=700)
        self.label=ttk.Label(self.señalestemporales, text="IFFT DOMINIO DEL TIEMPO", font=fuente, padding=(5,5))
        self.salir=ttk.Button(self.señalestemporales, text="cerrar", style='B.TButton', command=self.goback2)
        
        #RowsandColumns
        self.señalestemporales.rowconfigure(0, weight=1)
        self.señalestemporales.rowconfigure(1, weight=2)
        self.señalestemporales.rowconfigure(2, weight=2)
        self.señalestemporales.rowconfigure(3, weight=1)
        self.señalestemporales.columnconfigure(0, weight=1)
        self.señalestemporales.columnconfigure(1,weight=2)
        self.señalestemporales.columnconfigure(2,weight=2)
        self.señalestemporales.columnconfigure(3,weight=1)
        
        #Grid
        self.label.grid(column=1, columnspan=2, row=0, sticky="ns")
        self.salir.grid(column=3, row=3, sticky="ne")
        self.canvas.grid(column=1, columnspan=2, row=1, rowspan=2, sticky="e")
        
        
        # Function Plots
        global time_i
        global S_nc_i_tiempo
        global S_c_i_tiempo
        global temporal_i
        
        self.fig, self.axs=plt.subplots(2,2)
        self.fig.suptitle('IFFT Time Domain')
        self.axs[0,0].plot(time_i*1e9,S_nc_i_tiempo)
        self.axs[0,0].set_title('IFFT SIN MODELO')
        self.axs[0,0].set_xlabel('time (ns)')
        self.axs[0,0].set_xlim([-20,20])
        self.axs[0,1].plot(time_i*1e9,S_c_i_tiempo)
        self.axs[0,1].set_title('IFFT CON MODELO')
        self.axs[0,1].set_xlabel('time (ns)')
        self.axs[0,1].set_xlim([-20,20])
        self.axs[1,0].plot(time_i*1e9,temporal_i)
        self.axs[1,0].set_title('IFFT DIFERENCIA (ABS)')
        self.axs[1,0].set_xlabel('time (ns)')
        self.axs[1,0].set_xlim([-20,20])
        
        self.canvas = FigureCanvasTkAgg(self.fig, master=self.señalestemporales)
        self.canvas.get_tk_widget().grid(column=1, columnspan=2, row=1, rowspan=2)
        self.canvas.draw()
     

    def goback3(self):
        self.ifft.withdraw()
        self.guiDatos.deiconify()
        
    def ifft(self):
        self.guiDatos.withdraw()
        self.ifft=Toplevel()
        self.ifft.geometry('1280x1024')
        self.ifft.resizable(0,0)
        self.ifft.title('Resultados Método Directo')
        fuente = font.Font(weight='bold', size=16)
        self.ifft.anchor("nw")
        style=ttk.Style()
        style.configure('B.TButton', font=("Roboto Cn", 14))
        
         #Wdigets
        self.canvas=tk.Canvas(self.ifft, width=900, height=700)
        self.label=ttk.Label(self.ifft, text="IFFT MÉTODO DIRECTO", font=fuente, padding=(5,5))
        self.salir=ttk.Button(self.ifft, text="cerrar",style='B.TButton', command=self.goback3)
        
        #RowsandColumns
        self.ifft.rowconfigure(0, weight=1)
        self.ifft.rowconfigure(1, weight=2)
        self.ifft.rowconfigure(2, weight=2)
        self.ifft.rowconfigure(3, weight=1)
        self.ifft.columnconfigure(0, weight=1)
        self.ifft.columnconfigure(1,weight=2)
        self.ifft.columnconfigure(2,weight=2)
        self.ifft.columnconfigure(3,weight=1)
        
        #Grid
        self.label.grid(column=1, columnspan=2, row=0)
        self.salir.grid(column=3, row=3, sticky="ne")
        self.canvas.grid(column=1, columnspan=2, row=1, rowspan=2)
        # #Canvasimage
        
        self.img=ImageTk.PhotoImage(Image.open("IFFT.png"))
        self.canvas.create_image(0,0,image=self.img, anchor="nw")
        
    def goback4(self):
        self.das.withdraw()
        self.guiDatos.deiconify()
        
    def das(self):
        self.guiDatos.withdraw()
        self.das=Toplevel()
        self.das.geometry('1280x1024')
        self.das.resizable(0,0)
        self.das.title('Resultados DAS/DMAS/CWB')
        fuente = font.Font(weight='bold', size=16)
        self.das.anchor("nw")
        style=ttk.Style()
        style.configure('B.TButton', font=("Roboto Cn", 14))
        
         #Wdigets
        self.canvas=tk.Canvas(self.das, width=900, height=700)
        self.label=ttk.Label(self.das, text="DAS/DMAS/CWB", font=fuente, padding=(5,5))
        self.salir=ttk.Button(self.das, text="cerrar",style='B.TButton',  command=self.goback4)
        
        #RowsandColumns
        self.das.rowconfigure(0, weight=1)
        self.das.rowconfigure(1, weight=2)
        self.das.rowconfigure(2, weight=2)
        self.das.rowconfigure(3, weight=1)
        self.das.columnconfigure(0, weight=1)
        self.das.columnconfigure(1,weight=2)
        self.das.columnconfigure(2,weight=2)
        self.das.columnconfigure(3,weight=1)
        
        #Grid
        self.label.grid(column=1, columnspan=2, row=0)
        self.salir.grid(column=3, row=3, sticky="ne")
        self.canvas.grid(column=1, columnspan=2, row=1, rowspan=2)
        # #Canvasimage
        
        self.img=ImageTk.PhotoImage(Image.open("DAS.png"))
        self.canvas.create_image(0,0,image=self.img, anchor="nw")
        
    def goback5(self):
        self.plot3d.withdraw()
        self.guiDatos.deiconify()
        
    def plot3d(self):
        self.guiDatos.withdraw()
        self.plot3d=Toplevel()
        self.plot3d.geometry('1280x1024')
        self.plot3d.resizable(0,0)
        self.plot3d.title('Imagen 3D')
        fuente = font.Font(weight='bold', size=16)
        self.plot3d.anchor("nw")
        style=ttk.Style()
        style.configure('B.TButton', font=("Roboto Cn", 14))
        
        #Wdigets
        self.canvas=tk.Canvas(self.plot3d, width=900, height=700)
        self.label=ttk.Label(self.plot3d, text="IMAGEN 3D", font=fuente, padding=(5,5))
        self.salir=ttk.Button(self.plot3d, text="cerrar", style='B.TButton',command=self.goback5)
        
        #RowsandColumns
        self.plot3d.rowconfigure(0, weight=1)
        self.plot3d.rowconfigure(1, weight=2)
        self.plot3d.rowconfigure(2, weight=2)
        self.plot3d.rowconfigure(3, weight=1)
        self.plot3d.columnconfigure(0, weight=1)
        self.plot3d.columnconfigure(1,weight=2)
        self.plot3d.columnconfigure(2,weight=2)
        self.plot3d.columnconfigure(3,weight=1)
        
        #Grid
        self.label.grid(column=1, columnspan=2, row=0)
        self.salir.grid(column=3, row=3, sticky="ne")
        self.canvas.grid(column=1, columnspan=2, row=1, rowspan=2)
        # #Canvasimage
        
        self.img=ImageTk.PhotoImage(Image.open("imagen3d.png"))
        self.canvas.create_image(0,0,image=self.img, anchor="nw")
       
        
    def leerfichero(self):
        self.leerfichero=Toplevel()
        self.leerfichero.geometry('1280x1024')
        self.leerfichero.resizable(0,0)
        self.leerfichero.title('Resultados Resonadores')
        self.leerfichero.anchor("nw")
        style=ttk.Style()
        style.configure('B.TButton', font=("Roboto Cn", 14))
        
        #Código Resonadores 
        
        messagebox.showinfo(message="Elige el s2p de los resonadores medidos a 2.3 GHz")
        self.selectedfile=filedialog.askopenfilenames()
        messagebox.showinfo(message="Elige el s2p de los resonadores medidos a 4.6 GHz")
        self.selectedfile2=filedialog.askopenfilenames()
        
        for n in range (0,len(self.selectedfile)):
            s2p=Network(self.selectedfile[n])
            freq_sim=s2p.f
            x=s2p.s
            s21=x[:,1,0]
            s21=np.reshape(s21,(len(x)))
            s21=abs(s21)
            s21_db=control.mag2db(s21)
            A=[s21_db,freq_sim]
             
            locs=find_peaks(s21_db) #x-axis frequencies, equivalente of locs
            pks_limite=s21_db[locs[0]]
            D=A.pop(0)
            maximo=np.amax(pks_limite)
            maxfreq=freq_sim[np.nonzero(D == maximo)] #indices de D donde se encuentra el valor "maximo"
            posmax_tuple=np.nonzero(D == maximo)
            posmax=int(posmax_tuple[0])
            limite_valor=freq_sim.flat[np.abs(freq_sim - 1.5e9).argmin()]
            f_1=np.where(freq_sim == limite_valor)
            f_pos_limite_1=int(f_1[0])
    
            limite_valor_h=freq_sim.flat[np.abs(freq_sim - 2.5e9).argmin()]
            f_h=np.where(freq_sim == limite_valor_h)
            f_pos_limite_h=int(f_h[0])
            s21_f1=s21_db[f_pos_limite_1:posmax]
            f1_pos_valor=s21_f1.flat[np.abs(s21_f1- (maximo-3)).argmin()]
            f1_pos_tuple=np.where(s21_f1 == f1_pos_valor)
            f1_pos=int(f1_pos_tuple[0])
            f1=freq_sim[np.nonzero(D == s21_f1[f1_pos])]
            s21_fh=s21_db[posmax:f_pos_limite_h]
            fh_pos_valor=s21_fh.flat[np.abs(s21_fh-(maximo-3)).argmin()]
            fh_pos_tuple=np.where(s21_fh==fh_pos_valor)
            fh_pos=int(fh_pos_tuple[0])
            fh=freq_sim[np.nonzero(D==s21_fh[fh_pos])]
            fr_hz=((f1+fh)/2)/1e9
            if n==0:
                p = [2804455.266531230, -34775726.166651500, 179516710.235833000, -493794135.379426000, 763352776.155219000, -628813945.034136000, 215640634.339272000]
                d=np.polyval(p, fr_hz)
                epsr1=d #EPRELATIVASILON 
                freq_sim1=freq_sim
                s21_db_1=s21_db
            elif n==1:
                p_s = [4658530.03384399, -57926787.09125790, 299932972.20137200, -827740199.46856900, 1284145207.36901000, -1061848774.47782000, 365622060.65799000];
                d_s=np.polyval(p_s, fr_hz)
                epsr2=d_s #Epsilon relativa
                freq_sim12=freq_sim
                s21_db_12=s21_db
            
            
        for m in range (0,len(self.selectedfile2)):
            s2p_2=Network(self.selectedfile2[m])
            freq_sim2=s2p_2.f
            x2=s2p_2.s
            s21_2=x2[:,1,0]
            s21_2=np.reshape(s21_2,(len(x2)))
            s21_2=abs(s21_2)
            s21_db_2=control.mag2db(s21_2)
            B=[s21_db_2, freq_sim2].pop(0)
           
            limite_valor_2=freq_sim2.flat[np.abs(freq_sim2 - 2.5e9).argmin()]
            f_1_2=np.where(freq_sim2 == limite_valor_2)
            f_pos_limite_1_2=int(f_1_2[0])
    
            limite_valor_h_2=freq_sim2.flat[np.abs(freq_sim2 - 4.8e9).argmin()]
            f_h_2=np.where(freq_sim2 == limite_valor_h_2)
            f_pos_limite_h_2=int(f_h_2[0])
            locs_2=find_peaks(s21_db_2) #x-axis frequencies, equivalente of locs
            pks_2=s21_db_2[locs_2[0]]
            pks_limite_2=pks_2[:1265]
            maximo_2=np.amax(pks_limite_2)
            maxfreq_2=freq_sim2[np.nonzero(B == maximo_2)] #indices de B donde se encuentra el valor "maximo"
            posmax_tuple_2=np.nonzero(B == maximo_2)
            posmax_2=int(posmax_tuple_2[0])
            s21_f1_2=s21_db_2[f_pos_limite_1_2:posmax_2]
            f1_pos_valor_2=s21_f1_2.flat[np.abs(s21_f1_2- (maximo_2-3)).argmin()]
            f1_pos_tuple_2=np.where(s21_f1_2 == f1_pos_valor_2)
            f1_pos_2=int(f1_pos_tuple_2[0])
            f1_2=freq_sim2[np.nonzero(B == s21_f1_2[f1_pos_2])]
            s21_fh_2=s21_db_2[posmax_2:f_pos_limite_h_2]
            fh_pos_valor_2=s21_fh_2.flat[np.abs(s21_fh_2-(maximo_2-3)).argmin()]
            fh_pos_tuple_2=np.where(s21_fh_2==fh_pos_valor_2)
            fh_pos_2=int(fh_pos_tuple_2[0])
            fh_2=freq_sim2[np.nonzero(B==s21_fh_2[fh_pos_2])]
            fr_hz_2=((f1_2+fh_2)/2)/1e9
            if m==0:
                p_2=[281899.7268409730, -6882159.2253814500, 69979128.3734270000, -379349042.1607980000, 1156280004.9543100000 -1878971207.2311700000, 1271756368.3284800000]
                d_2=np.polyval(p_2, fr_hz_2)
                epsr3=d_2
                freq_sim21=freq_sim2
                s21_db_21=s21_db_2
                
            elif m==1:
                p_s_2=[663881.629879475000000, -16120760.390881800000000, +163048928.829659000000000, -879225875.595082000000000, +2665995606.747500000000000, -4309964167.361000000000000, +2902256714.794430000000000]
                d_s_2=np.polyval(p_s_2,fr_hz_2)
                epsr4=d_s_2
                freq_sim22=freq_sim2
                s21_db_22=s21_db_2
        
        if epsr3 <= ((epsr1+epsr2)/2)-5 and epsr4 <=((epsr1+epsr2)/2)-5:
            media=(epsr1+epsr2)/2
        
        elif epsr3 > ((epsr1+epsr2)/2)+2 and epsr4 >((epsr1+epsr2)/2)+2:
            media=(epsr1+epsr2)/2
    
        elif epsr3<= ((epsr1+epsr2)/2)-5 and epsr4 > ((epsr1+epsr2)/2)+2:
            media=(epsr1+epsr2)/2
    
        elif epsr4 <= ((epsr1+epsr2)/2)-5 and epsr3 > ((epsr1+epsr2)/2)+2:
        
            media=(epsr1+epsr2)/2
        
        elif epsr3 <= ((epsr1+epsr2)/2)-5:
            media= (epsr1 +epsr2 +epsr4)/3
        
        elif epsr3 > ((epsr1+epsr2)/2)+2:
            media= (epsr1+epsr2+epsr4)/3
        
        elif epsr4 <= ((epsr1+epsr2)/2)-5:
            media= (epsr1+epsr2+epsr3)/3
    
        elif epsr4 > ((epsr1+epsr2)/2)+2:
            media= (epsr1+epsr2+epsr3)/3
        
        else :
            media=(epsr1+epsr2+epsr3+epsr4)/4
            
        # self.frame=ttk.Frame(self.guiDatos)
        # self.frame.grid(column=2, row=0, columnspan=5, rowspan=9)
        # self.canvas = FigureCanvasTkAgg(self.fig, master=self.frame)
        # self.canvas.get_tk_widget().pack()

        # plotim = PhotoImage(file='C:/Workspace/imagenes/plot.png')
        # self.imagen1 = ttk.Label(self.raiz, image = plotim, anchor="center")
        
        #texts and labels
        self.ctext1 = tk.Text(self.leerfichero, width=5, height=2)
        self.ctext2 = tk.Text(self.leerfichero,width=5, height=2)       
        self.ctext3 = tk.Text(self.leerfichero, width=5,height=2)       
        self.ctext4 = tk.Text(self.leerfichero,width=5,height=2)        
        self.ctext5 = tk.Text(self.leerfichero,width=5,height=2)       
        # self.ctext6 = tk.Text(self.guiDatos,width=5,height=2)
        self.etiq=ttk.Label(self.leerfichero, text="Gráficas y EPSRs Resultantes de los ficheros s2p", font="fuente 12 bold")
        self.etiq1 = ttk.Label(self.leerfichero, text="Epsr1 @2.5GHz", font="fuente 10")      
        self.etiq2 = ttk.Label(self.leerfichero, text="Epsr2 @2.5GHz", font="fuente 10")       
        self.etiq3 = ttk.Label(self.leerfichero, text="Epsr MEDIA", font="fuente 10 bold")     
        self.etiq4 = ttk.Label(self.leerfichero, text="Epsr3 @4.3GHz", font="fuente 10" )       
        self.etiq5 = ttk.Label(self.leerfichero, text="Epsr4 @4.3GHz", font="fuente 10") 
        self.close= ttk.Button(self.leerfichero, text="Cerrar",style='B.TButton', command=self.leerfichero.withdraw)
        
        #grid
        self.leerfichero.columnconfigure(0, weight=1)
        self.leerfichero.columnconfigure(1, weight=1)
        self.leerfichero.columnconfigure(2, weight=1)
        self.leerfichero.columnconfigure(3, weight=1)
        self.leerfichero.columnconfigure(4, weight=1)
        self.leerfichero.columnconfigure(5, weight=1)
        self.leerfichero.rowconfigure(0, weight=1)
        self.leerfichero.rowconfigure(1, weight=3)
        self.leerfichero.rowconfigure(2, weight=1)
        self.leerfichero.rowconfigure(3, weight=1)
        self.leerfichero.rowconfigure(4, weight=1)
        
        
        self.etiq.grid(row=0, column=0, columnspan=6, sticky="nsew")
        self.etiq.configure(anchor=CENTER)
        self.ctext1.grid(column=0, row=3, padx=5, pady=5, sticky="nsew")
        self.ctext2.grid(column=1, row=3, padx=5, pady=5, sticky="nsew")
        self.ctext3.grid(column=2, row=3, padx=5, pady=5, sticky="nsew")
        self.ctext4.grid(column=3, row=3, padx=5, pady=5, sticky="nsew")
        self.ctext5.grid(column=4, row=3, padx=5, pady=5, sticky="nsew")
        self.close.grid(column=4, row=4, padx=5, pady=5, sticky="e")
        self.etiq1.grid(column=0, row=2,padx=5, pady=5, sticky="nsew")
        self.etiq1.configure(anchor=CENTER)
        self.etiq2.grid(column=1, row=2,padx=5, pady=5, sticky="nsew")
        self.etiq2.configure(anchor=CENTER)
        self.etiq3.grid(column=2, row=2, padx=5, pady=5, sticky="nsew")
        self.etiq3.configure(anchor=CENTER)
        self.etiq4.grid(column=3, row=2,padx=5, pady=5, sticky="nsew")
        self.etiq4.configure(anchor=CENTER)
        self.etiq5.grid(column=4, row=2,padx=5, pady=5, sticky="nsew")
        self.etiq5.configure(anchor=CENTER)
      
        # self.f=Figure(figsize=(6,5))
        # self.f.add_subplot(111).plot(freq_sim1,s21_db_1)
        # self.f.add_subplot(111).plot(freq_sim12, s21_db_12)
        
        # self.frame=ttk.Frame(self.leerfichero)
        # self.frame.grid(column=0, row=0, columnspan=2)
        # self.canvas = FigureCanvasTkAgg(self.f, master=self.leerfichero)
        # self.canvas.get_tk_widget().grid(column=0, row=1, columnspan=3)
        
        self.f=plt.figure(figsize=(6,5))
        plt.plot(freq_sim1,s21_db_1, 'b')
        plt.plot(freq_sim12, s21_db_12, 'g')
        plt.xlabel('f(GHz)')
        plt.ylabel('dB')
        plt.title('Resonadores @ 2.3 GHz')
        plt.legend(['Resonador 1', 'Resonador 2']) 
        self.canvas = FigureCanvasTkAgg(self.f, master=self.leerfichero)
        self.canvas.get_tk_widget().grid(column=0, row=1, columnspan=3)
       
        
        
        self.f2=plt.figure(figsize=(6,5))
        plt.plot(freq_sim21, s21_db_21,'b')
        plt.plot(freq_sim22, s21_db_22, 'g')
        plt.xlabel('f(GHz)')
        plt.ylabel('dB')
        plt.title('Resonadores @ 4.6 GHz')
        plt.legend(['Resonador 3', 'Resonador 4']) 
        # self.f2.add_subplot(111).plot(freq_sim21,s21_db_21)
        # self.f2.add_subplot(111).plot(freq_sim22, s21_db_22)
        # self.frame2=ttk.Frame(self.leerfichero)
        # self.frame2.grid(column=3, row=0, columnspan=2)
        self.canvas2=FigureCanvasTkAgg(self.f2, master=self.leerfichero)
        self.canvas2.get_tk_widget().grid(column=3, row=1, columnspan=3)
       
        
        self.ctext1.insert("1.0", epsr1)
        self.ctext2.insert("1.0", epsr2)
        self.ctext3.insert("1.0", media)
        self.ctext4.insert("1.0", epsr3)
        self.ctext5.insert("1.0", epsr4)
        # self.ctext6.insert("1.0", "")
        # self.f.savefig("plot.png")
    

    def guiMedirVNA(self):
        print("Midiendo VNA...")     
        
def main():
    mi_app = guiMain()
    return 0

if __name__ == '__main__':
    main()
    
