%function python_plot
%% Borramos todo
clear
clc
%%
[vertices,faces,normals] = stlread('C:\Workspace\recipientemamasinagujeros.stl');
stlPlot(vertices,faces,'mama');

%% Inicializacin variables necesarias para el diseo
c_v = 299792458;
er1 = 1; %de aqui se modifica la Er del material
er2 = 1;
speed1 = c_v./sqrt(er1);  
speed2 = c_v./sqrt(er2); 
% Todas las distancias en (cm)
radio_antena =  fix(max(vertices(:,1)))./1000; % radio hasta el centro partiendo desde las antenas (m)
gap= 0.005; % espesor del contenedor de la mama (m)
espesor = 2.*(radio_antena-gap); % Espesor de la muestra para la realizacin de la estimacin de er

% configuracin elementos Visualizacion
analisis_temporal=0; % Seales Temporales
analisis=1; % COmparacin seales temporales
plot_S21=0; %Visualizamos las seales de S12
estimacion=0; % Realizacion del calculo de er
view_3d=1;  % Trabajos en un entorno 2D else 3D
view_3d_level=1; % Si view_3d=1 podemos definir visualizacin 2 niveles
max_rango_plot=50; % mxima distancia a visualizar en las imagenes temporales

if view_3d==1
    vector_plot=[1 2 9 8 5 6 13 4 3 12 10 7 16 14 15 11];
    level_1=vector_plot(1:8);
    level_2=vector_plot(9:14);
    level_3=vector_plot(15:16);
else
    vector_plot=[1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16];
end

%% Cargamos las diferentes medidas de las antenas sin cabeza
% Se filtra por parametros sin cabeza y con cabeza.
[FileName, PathName]= uigetfile('medidaantref*.s2p','Ficheros Sxx sin cabeza','MultiSelect','on');
PathName
[FileName1, PathName1]= uigetfile('medidaant*.s2p','Ficheros Sxx con cabeza','MultiSelect','on');
PathName1
[row,nfiles]=size(FileName);
%% figure;
disp('-- start import Sxx parameters --');
    for n = 1:nfiles
        hs_nc=sparameters(char(fullfile(PathName,FileName(n))));
        hs_c=sparameters(char(fullfile(PathName1,FileName1(n))));     
        if n<=4
            S11_nc(n,:)  =smooth(hs_nc.Parameters(1,1,:));  
            S11_nc(n+4,:)=smooth(hs_nc.Parameters(2,2,:));
            S21_nc(n,:)  =smooth(hs_nc.Parameters(2,1,:));  
            S21_nc(n+4,:)=smooth(hs_nc.Parameters(1,2,:)); 
            S11_c(n,:)   =smooth(hs_c.Parameters(1,1,:));  
            S11_c(n+4,:) =smooth(hs_c.Parameters(2,2,:));
            S21_c(n,:)   =smooth(hs_c.Parameters(2,1,:));
            S21_c(n+4,:) =smooth(hs_c.Parameters(1,2,:));
            tg_nc(n,:)=groupdelay(hs_nc,2,1)';
            tg_nc(n+4,:)=groupdelay(hs_nc,1,2)';
            tg_c(n,:)=groupdelay(hs_c,2,1)';
            tg_c(n+4,:)=groupdelay(hs_c,1,2)';
        else
            S11_nc(n+4,:)=smooth(hs_nc.Parameters(1,1,:));  
            S11_nc(n+8,:)=smooth(hs_nc.Parameters(2,2,:));
            S21_nc(n+4,:)=smooth(hs_nc.Parameters(2,1,:));
            S21_nc(n+8,:)=smooth(hs_nc.Parameters(1,2,:));
            S11_c(n+4,:) =smooth(hs_c.Parameters(1,1,:));  
            S11_c(n+8,:) =smooth(hs_c.Parameters(2,2,:));
            S21_c(n+4,:) =smooth(hs_c.Parameters(2,1,:)); 
            S21_c(n+8,:) =smooth(hs_c.Parameters(1,2,:)); 
            tg_nc(n+4,:)=groupdelay(hs_nc,2,1)';
            tg_nc(n+8,:)=groupdelay(hs_nc,1,2)';
            tg_c(n+4,:)=groupdelay(hs_c,2,1)';
            tg_c(n+8,:)=groupdelay(hs_c,1,2)';
        end
        
        if analisis_temporal==1
            figure
            subplot(2,2,1)
            hold on
            grid on
            plot(hs_c.Frequencies*1e-9,10*log(abs(S11_nc(n,:))));
            plot(hs_c.Frequencies*1e-9,10*log(abs(S11_nc(n+4,:))));
            title('S11 NO cabeza ');
            xlabel('Frequency (GHz)')
            ylabel('Magnitude (dB)')
            subplot(2,2,2)
            hold on
            grid on
            plot(hs_c.Frequencies*1e-9,10*log(abs(S21_nc(n,:))));
            plot(hs_c.Frequencies*1e-9,10*log(abs(S21_nc(n+4,:))));
            title('S21 NO cabeza ');
            xlabel('Frequency (GHz)')
            ylabel('Magnitude (dB)')
            subplot(2,2,3)
            hold on
            grid on
            plot(hs_c.Frequencies*1e-9,10*log(abs(S11_c(n,:))));
            plot(hs_c.Frequencies*1e-9,10*log(abs(S11_c(n+4,:))));
            title('S11 cabeza ');
            xlabel('Frequency (GHz)')
            ylabel('Magnitude (dB)')
            subplot(2,2,4)
            hold on
            grid on
            plot(hs_c.Frequencies*1e-9,10*log(abs(S21_c(n,:))));
            plot(hs_c.Frequencies*1e-9,10*log(abs(S21_c(n+4,:))));
            title('S21 cabeza ');
            xlabel('Frequency (GHz)')
            ylabel('Magnitude (dB)')
        end
    end
    [nElements,ifft_val]=size(S11_nc);
    f= hs_nc.Frequencies;
    disp('-- import Sxx parameters OK--');
%% Procesado de Datos NO interp
disp('-- S-parameters frequency to Time IFFT version--');
Fs = 12e9; %Sampling frequency in Hz
%tipo de ventana, hamming, hann, bohmanwin,nuttallwin,barlett, blackman,recwin,chebwin,kaiser,trian                        
Window=bohmanwin(ifft_val)'; %Utilizamos un tipo de ventana para intentar realzar los picos de las medidas

r_t= (length(f)-1)/(max(f)-min(f)); % time resolution
ss=r_t/(length(f)-1); % sample Size 
time=linspace(-(length(f)-1)/2*ss,(length(f)-1)/2*ss,length(f));
t_plot=linspace(0,max(time),length(f));
dist_plot = t_plot * speed1 / 2; %distance axis in meters max value 20m

S11_c_vent = zeros(nElements,ifft_val);
S11_nc_vent = zeros(nElements,ifft_val);
S21_c_vent = zeros(nElements,ifft_val);
S21_nc_vent = zeros(nElements,ifft_val);

for k = vector_plot
	S11_c_vent(k,:) = S11_c(k,:).*Window; % realizamos un enventanado de los datos para suavizar
    S11_nc_vent(k,:) =S11_nc(k,:).*Window; % realizamos un enventanado de los datos para suavizar
    S21_c_vent(k,:) = S21_c(k,:).*Window; % realizamos un enventanado de los datos para suavizar
    S21_nc_vent(k,:) =S21_nc(k,:).*Window; % realizamos un enventanado de los datos para suavizar
end
S11_c_tiempo = zeros(nElements,ifft_val);
S11_nc_tiempo = zeros(nElements,ifft_val);
S21_c_tiempo = zeros(nElements,ifft_val);
S21_nc_tiempo = zeros(nElements,ifft_val);
temporal11= zeros(nElements,ifft_val);
temporal21= zeros(nElements,ifft_val);
for k = vector_plot
	S11_c_tiempo(k,:) = real(ifft(S11_c_vent(k,:))); % realizamos la inversa de la FFT de la seal sin antenas
    S11_nc_tiempo(k,:) =real(ifft(S11_nc_vent(k,:))); % realizamos la inversa de la FFT de la seal con antenas
    temporal11(k,:)= (S11_c_tiempo(k,:) - S11_nc_tiempo(k,:)); % eliminamos el comportamiento de las antenas sin cabeza
    
    S21_c_tiempo(k,:) = real(ifft(S21_c_vent(k,:))); % realizamos la inversa de la FFT de la seal sin antenas
    S21_nc_tiempo(k,:) =real(ifft(S21_nc_vent(k,:))); % realizamos la inversa de la FFT de la seal con antenas
    temporal21(k,:)= (S21_c_tiempo(k,:) - S21_nc_tiempo(k,:)); % eliminamos el comportamiento de las antenas sin cabeza
end

    medida11=abs(temporal11)./max(max(abs(temporal11))); % promediamos las muestras por el mayor valor de todas las medidas
    medida12=abs(temporal21)./max(max(abs(temporal21))); % promediamos las muestras por el mayor valor de todas las medidas

    if analisis==1
        rango=[0 max_rango_plot];
        figure
        subplot(2,2,1)
        waterfall(dist_plot*100,vector_plot,S11_nc_tiempo);
        title('IFFT NO cabeza S11 ')
        xlabel('distance (cm)')   
        xlim(rango)
        subplot(2,2,2)
        waterfall(dist_plot*100,vector_plot,S11_c_tiempo);
        title('IFFT Cabeza S11')      
        xlabel('distance (cm)') 
        xlim(rango)
        subplot(2,2,3)
        waterfall(dist_plot*100,vector_plot,medida11);
        title('IFFT (cabeza - sistema) S11')
        xlim(rango)
        xlabel('distance (cm)')
        subplot(2,2,4)
        title('IFFT (cabeza - sistema) S11')
        pcolor(dist_plot*100,vector_plot,medida11);shading interp;
        xlabel('distance (cm)')
        xlim(rango)
        if plot_S21==1
            figure
            subplot(2,2,1)
            waterfall(dist_plot*100,vector_plot,S21_nc_tiempo);
            title('IFFT NO cabeza S12')
            xlabel('distance (cm)')
            xlim(rango)
            subplot(2,2,2)
            waterfall(dist_plot*100,vector_plot,S21_c_tiempo);
            title('IFFT Cabeza S12')      
            xlabel('distance (cm)') 
            xlim(rango)
            subplot(2,2,3)
            waterfall(dist_plot*100,vector_plot,medida12);
            title('IFFT (cabeza - sistema) S12')
            xlim(rango)
            xlabel('distance (cm)')
            subplot(2,2,4)
            pcolor(dist_plot*100,vector_plot,medida12);shading interp;
            xlabel('distance (cm)')
            xlim(rango)
        end
    end
    S11_nc_tiempo = ifftshift(S11_nc_tiempo);
    S11_c_tiempo = ifftshift(S11_c_tiempo);
	medida11=ifftshift(medida11);
    temporal11 = ifftshift(temporal11); % invertimos los ejes temporales para pintar donde toca la seal en el tiempo
    S21_nc_tiempo = ifftshift(S21_nc_tiempo);
    S21_c_tiempo = ifftshift(S21_c_tiempo);
	medida12=ifftshift(medida12);
    temporal21 = ifftshift(temporal21); % invertimos los ejes temporales para pintar donde toca la seal en el tiempo
    
    if analisis_temporal==1 % Seales Temporales
        figure;
        subplot(2,3,1)
        plot(time*1e9,S11_nc_tiempo)
        title('IFFT NO cabeza S11 ')
        xlabel('time (ns)')
        xlim([-20 20])
        subplot(2,3,2)
        plot(time*1e9,S11_c_tiempo)
        title('IFFT cabeza S11')
        xlabel('time (ns)')
        xlim([-20 20])
        subplot(2,3,3)
        plot(time*1e9,temporal11)
        title('IFFT DIFERENCIA S11 ')
        xlabel('time (ns)')
        xlim([-50 50])
        %figure;
        subplot(2,3,[4 5 6])
        plot(time*1e9,medida11);
        title('IFFT DIFERENCIA (ABS) S11 ')
        xlabel('time (ns)')
        xlim([-50 50])
        if plot_S21==1
            figure;
            subplot(2,3,1)
            plot(time*1e9,S21_nc_tiempo)
            title('IFFT NO cabeza S12 ')
            xlabel('time (ns)')
            xlim([-20 20])
            subplot(2,3,2)
            plot(time*1e9,S21_c_tiempo)
            title('IFFT cabeza S12')
            xlabel('time (ns)')
            xlim([-20 20])
            subplot(2,3,3)
            plot(time*1e9,temporal21)
            title('IFFT DIFERENCIA S12 ')
            xlabel('time (ns)')
            xlim([-50 50])
            %figure;
            subplot(2,3,[4 5 6])
            plot(time*1e9,medida12);
            title('IFFT DIFERENCIA (ABS) S12 ')
            xlabel('time (ns)')
            xlim([-50 50])
        end
    end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   
%% Procesado de Datos interpolacion
disp('-- S-parameters frequency to Time IFFT interpol version--'); 
Fsi = 12e9; %Sampling frequency in Hz
DF = f(2)-f(1);
F_Axis_i = 0:DF:Fsi-DF;
ifft_val_i=length(F_Axis_i);

r_t_i= (length(F_Axis_i)-1)/(max(F_Axis_i)-min(F_Axis_i)); % time resolution
ss_i=r_t_i/(length(F_Axis_i)-1); % sample Size 
time_i=linspace(-(length(F_Axis_i)-1)/2*ss_i,(length(F_Axis_i)-1)/2*ss_i,length(F_Axis_i));
t_plot_i=linspace(0,max(time_i),length(F_Axis_i));
dist_plot_i = t_plot_i * speed1 / 2; %distance axis in meters max value 20m
f_plot_i=[(-1.*(Fsi/2:-DF:0)) (DF:DF:(Fsi-DF)/2) ];

n1 = find(F_Axis_i<=f(1),1,'last');
S_nc_i = zeros(nElements,ifft_val_i);
S_c_i = zeros(nElements,ifft_val_i);
window_i = zeros(1,ifft_val_i);

window_i(n1+1:n1+length(f))= Window;
window_i(n1+size(f,1):ifft_val_i/2+1)=Window(end);
window_i(1:n1)=window_i(n1+1);
window_i(ifft_val_i/2+2:end) = conj(fliplr(window_i(2:ifft_val_i/2)));

for n = vector_plot  
	 S_nc_i(n,n1+1:n1+length(f))= S11_nc(n,:);
     S_nc_i(n,n1+size(f,1):ifft_val_i/2+1)=S11_nc(n,end);
     S_nc_i(n,1:n1)=S_nc_i(n,n1+1);
     S_nc_i(n,ifft_val_i/2+2:end) = conj(fliplr(S_nc_i(n,2:ifft_val_i/2)));
        
     S_c_i(n,n1+1:n1+length(f))= S11_c(n,:);
     S_c_i(n,n1+size(f,1):ifft_val_i/2+1)=S11_c(n,end);
     S_c_i(n,1:n1)=S_c_i(n,n1+1);
     S_c_i(n,ifft_val_i/2+2:end) = conj(fliplr(S_c_i(n,2:ifft_val_i/2))); 
end
    figure;
    subplot(3,1,1)
    plot(f_plot_i,mag2db(fftshift(abs(S_nc_i(1,:)))));
    title('S11 Antena No Cabeza 1 Interpol ')
    xlabel('Frequency (GHz)')
    subplot(3,1,2)
    plot(f_plot_i,mag2db(fftshift(abs(S_c_i(1,:)))));
    title('S11 Antena Cabeza 1 Interpol ')
    xlabel('Frequency (GHz)')
    subplot(3,1,3)
    plot(f_plot_i,mag2db(fftshift(abs(window_i))));
    title('Ventana Bohman Utilizada ')
    xlabel('Frequency (GHz)')

S_c_i_vent = zeros(nElements,ifft_val_i);
S_nc_i_vent = zeros(nElements,ifft_val_i);
for k = vector_plot
	S_c_i_vent(k,:) = S_c_i(k,:).*window_i; % realizamos un enventanado de los datos para suavizar
    S_nc_i_vent(k,:) =S_nc_i(k,:).*window_i; % realizamos un enventanado de los datos para suavizar
end

S_c_i_tiempo = zeros(nElements,ifft_val_i);
S_nc_i_tiempo = zeros(nElements,ifft_val_i);
temporal_i= zeros(nElements,ifft_val_i);
medida_i= zeros(nElements,ifft_val_i);
% ifftshift
for k = vector_plot
	S_c_i_tiempo(k,:) = real(ifft(S_c_i_vent(k,:))); % realizamos la inversa de la FFT de la seal sin antenas
	S_nc_i_tiempo(k,:) =real(ifft(S_nc_i_vent(k,:))); % realizamos la inversa de la FFT de la seal con antenas
	temporal_i(k,:)= hilbert(S_c_i_tiempo(k,:)- S_nc_i_tiempo(k,:)); % eliminamos el comportamiento de las antenas sin cabeza
end

    medida_i=abs(temporal_i)./max(max(abs(temporal_i))); % promediamos las muestras por el mayor valor de todas las medidas
    
    if analisis==1
        rango=[0 max_rango_plot];
        figure
        subplot(2,2,1)
        waterfall(dist_plot_i*100,vector_plot,S_nc_i_tiempo);
        title('IFFT NO cabeza S11 interpol ')
        xlabel('distance (cm)')
        xlim(rango)
        subplot(2,2,2)
        waterfall(dist_plot_i*100,vector_plot,S_c_i_tiempo);
        title('IFFT Cabeza S11 interpol')      
        xlabel('distance (cm)') 
        xlim(rango)
        subplot(2,2,3)
        waterfall(dist_plot_i*100,vector_plot,medida_i);
        title('IFFT (cabeza - sistema) S11 interpol')
        xlim(rango)
        xlabel('distance (cm)')
        subplot(2,2,4)
        title('IFFT (cabeza - sistema) S11 interpol')
        pcolor(dist_plot_i*100,vector_plot,medida_i);shading interp;
        xlabel('distance (cm)')
        xlim(rango)
    end
    S_nci_tiempo = ifftshift(S_nc_i_tiempo);
    S_ci_tiempo = ifftshift(S_c_i_tiempo);
	medida_i=ifftshift(medida_i);
    temporal_i = ifftshift(temporal_i); % invertimos los ejes temporales para pintar donde toca la seal en el tiempo
    if analisis_temporal==1 % Seales Temporales
        figure;
        subplot(2,3,1)
        plot(time_i*1e9,S_nc_i_tiempo)
        title('IFFT NO cabeza S11 interpol')
        xlabel('time (ns)')
        xlim([-20 20])
        subplot(2,3,2)
        plot(time_i*1e9,S_c_i_tiempo)
        title('IFFT cabeza S11 interpol')
        xlabel('time (ns)')
        xlim([-20 20])
        subplot(2,3,3)
        plot(time_i*1e9,temporal_i)
        title('IFFT DIFERENCIA S11 ')
        xlabel('time (ns)')
        xlim([-50 50])
        %figure;
        subplot(2,3,[4 5 6])
        plot(time_i*1e9,medida_i);
        title('IFFT DIFERENCIA (ABS) S11 ')
        xlabel('time (ns)')
        xlim([-50 50])
    end
%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% It can be seen as a bandpass filter, or an adapted filter to the
% transmitted signal. 
% Could be interesting reviweing this pulse, to adapt it to the antenas
% bandwidth
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp('-- S-parameters frequency to Time ICZT  version--'); 

Fs = 12e9; %Sampling frequency in Hz
DF_c = f(2)-f(1);
F_Axis_c = 0:DF_c:Fs-DF_c;
ifft_val_c=length(F_Axis_c);

Amp=50*10^8;
tau=60*10^(-12);
paso=tau/100;
tin=7*tau;
Pulse = makePulse(Amp, tau, tin, ifft_val_c, Fs); % Make pulse 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Used to syncronize signals in time, or in other words, to eliminate delay
% caused by the filtering using the Gaussian pulse.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
m = length(f);
f1 = f(1);
f2 = f(end);
w = exp(1i*2*pi*(f2-f1)/(m*Fs));
a = exp(-1i*2*pi*f1/Fs);
Pulse_CZT = czt(Pulse,m,conj(w),conj(a)); %Pulse spectra

r_t_c= (length(f)-1)/(max(f)-min(f)); % time resolution
ss_c=r_t_c/(length(f)-1); % sample Size 
time_c=linspace(-(length(f)-1)/2*ss_c,(length(f)-1)/2*ss_c,length(f));
Time_Axis_c = (0:length(time_c)-1)*abs(time_c(2)-time_c(1)); %time axis in seconds
time_c = Time_Axis_c;
dist_c= time_c*speed1/2;

%CHIRP transform
S_nc_t = zeros(nElements,m); % preallocation, by span and zeropadding, Reference
S_c_t = zeros(nElements,m); % preallocation, by span and zeropadding, Target
medida_c =zeros(nElements,m); % preallocation, by span and zeropadding

for n=vector_plot %loop for each antenna   
    S_nc_t(n,:)= real(czt(S11_nc(n,:).*Pulse_CZT,m,w,a)); % Take known transfer function
    S_c_t(n,:)= real(czt(S11_c(n,:).*Pulse_CZT,m,w,a)); % Take known transfer function
    medida_c(n,:) = abs(hilbert(S_c_t(n,:) - S_nc_t(n,:))); %envolvente
end  
    medida_c=medida_c./(max(max(medida_c))); % promediamos las muestras por el mayor valor de todas las medidas

 if analisis==1
        rango=[0 max_rango_plot];
        figure
        subplot(2,2,1)
        waterfall(dist_c*100,vector_plot,S_nc_t);
        title('iCZT NO cabeza S11 ')
        xlabel('distance (cm)')
        xlim(rango)
        subplot(2,2,2)
        waterfall(dist_c*100,vector_plot,S_c_t);
        title('iCZT Cabeza S11')      
        xlabel('distance (cm)') 
        xlim(rango)
        subplot(2,2,3)
        waterfall(dist_c*100,vector_plot,medida_c);
        title('iCZT (cabeza - sistema) S11')
        xlim(rango)
        xlabel('distance (cm)')
        subplot(2,2,4)
        title('iCZT (cabeza - sistema) S11')
        pcolor(dist_c*100,vector_plot,medida_c);shading interp;
        xlabel('distance (cm)')
        xlim(rango)
    end

%% Creamos posiciones antenas y pesos en 3D
% una vez tenemos las seales en el tiempo pasamos a calcular los
% diferentes algoritmos de conformacion de imagen. creamos el entorno de
% trabajo y calculamos distancias y velocidades de onda desde las antenas a
% cada punto de la rejilla de interpolacion.
% Todas las distancias en (cm)
        
if view_3d==0
    disp('-- start 2D plotting results  --'); 
    MAX = 256; % Nmero de puntos utilizados en la superficie de interpolacin
            %Cuantos ms puntos, ms resolucin pero bastante ms lento de
            %computar 

    [xPos, yPos] = pol2cart((0:1/nElements:1-1/nElements)*2*pi, ones(1,nElements)*radio_antena);
    xPos=circshift(xPos,5);
    yPos=circshift(yPos,5);
    radio_interpol=radio_antena-gap;
    [r,theta] = meshgrid(linspace(radio_interpol,-radio_interpol,MAX),linspace(0,2*pi,MAX));
    X = r.*sin(theta);
    Y = r.*cos(theta);
    X=X(:)';
    Y=Y(:)';
    
    figure
    scatter(X.*1000,Y.*1000,100, 'filled');
    hold on
    scatter(xPos.*1000, yPos.*1000,100,'filled','r');
    xlabel('distance (mm)');
    ylabel('distance (mm)');
else
    disp('-- start 3D plotting results  --'); 
   
    antenas=readtable('./posicion_antenas.csv');   
    xPos= antenas.X'./1000; %(m)
    yPos= antenas.Y'./1000; %(m)
    zPos= antenas.Z'./1000; %(m)
    
    if view_3d_level==0
        MAX = 64; % Nmero de puntos utilizados en la superficie de interpolacin
            %Cuantos ms puntos, ms resolucin pero bastante ms lento de
            %computar 
    % espacio interpolacin
        minX_bd = fix(min(vertices(:,1)))./1000; % (m)
        maxX_bd = fix(max(vertices(:,1)))./1000; % (m)
        minY_bd = fix(min(vertices(:,3)))./1000; % (m)
        maxY_bd = fix(max(vertices(:,3)))./1000; % (m)
        minZ_bd = fix(min(vertices(:,2)))./1000; % (m)
        maxZ_bd = fix(max(vertices(:,2)))./1000; % (m)
        

        x_axis = linspace(minX_bd,maxX_bd,MAX);
        y_axis = linspace(minY_bd,maxY_bd,MAX);
        z_axis = linspace(minZ_bd,maxZ_bd,MAX);
        
        axes_ = {x_axis, y_axis, z_axis};
        [Xs, Ys, Zs] = ndgrid(axes_{:});
        if (abs(Ys) <= 0.023) & (abs(Xs) <= 0.023)
            area_ = Xs.^2 + Ys.^2+Zs.^2 <= maxX_bd.^2;
        else
            area_ = Xs.^2 + Ys.^2+Zs.^2 <= maxZ_bd.^2;
        end
        ndim = 3;
        coords = cell(1, ndim);
        domain_range = arrayfun(@(x) 1:size(area_, x), 1:ndim, 'UniformOutput', false);
        [coords{:}] = ndgrid(domain_range{:});

        coords = cellfun(@(x) x(area_), coords, 'UniformOutput', false);
        coords = arrayfun(@(n) axes_{n}(coords{n}), 1:3, 'UniformOutput', false);
        coords = cellfun(@(a) a(:), coords, 'UniformOutput', false);

        points = cat(2, coords{:});
        X=points(:, 1);
        Y=points(:, 2);
        Z=points(:, 3);
        
    else
        disp('-- start 2D level plotting results  --');
        MAX = 256; % Nmero de puntos utilizados en la superficie de interpolacin
            %Cuantos ms puntos, ms resolucin pero bastante ms lento de
            %computar 
            
        xPos_1=xPos(level_1);
        yPos_1=yPos(level_1);
        zPos_1=zPos(level_1);
        radio_interpol=max(xPos_1);
        [r,theta] = meshgrid(linspace(radio_interpol,-radio_interpol,MAX),linspace(0,2*pi,MAX));
        X = r.*sin(theta);
        Y = r.*cos(theta);
        X_1=X(:)';
        Y_1=Y(:)';
        
        xPos_2=xPos(level_2);
        yPos_2=yPos(level_2);
        zPos_2=zPos(level_2); 
        radio_interpol=max(xPos_2);
        [r,theta] = meshgrid(linspace(radio_interpol,-radio_interpol,MAX),linspace(0,2*pi,MAX));
        X = r.*sin(theta);
        Y = r.*cos(theta);
        X_2=X(:)';
        Y_2=Y(:)';        
    end
end
%% Calculamos Distancias y retardos
if view_3d==0 
    Distance = zeros(nElements,length(X));
    delay=zeros( nElements,length(X));
    for k = vector_plot
        for m = 1:length(X)
            Distance(k,m) = sqrt((xPos(k) - X(m))^2 + (yPos(k) - Y(m))^2);   
            delay(k,m)=2*Distance(k,m)/speed1 ;
        end
    end
else
    if view_3d_level==0
        Distance = zeros(nElements,length(X));
        delay=zeros( nElements,length(X));
        for k = vector_plot
            for m = 1:length(X)
                Distance(k,m) = sqrt((xPos(k) - X(m))^2 + (yPos(k) - Y(m))^2 + (zPos(k) - Z(m))^2 );
                delay(k,m)=2*Distance(k,m)/speed1 ;
            end
        end
    else
        Distance_1 = zeros(length(level_1),length(X_1));
        delay_1=zeros( length(level_1),length(X_1));
        Distance_2 = zeros(length(level_2),length(X_2));
        delay_2=zeros( length(level_2),length(X_2));
        for k = length(level_1)
            for m = 1:length(X_1)     
                Distance_1(k,m) = sqrt((xPos_1(k) - X_1(m))^2 + (yPos_1(k) - Y_1(m))^2);   
                delay_1(k,m)=2*Distance_1(k,m)/speed1 ;
            end
        end
        for k = length(level_2)
            for m = 1:length(X_2)     
                Distance_2(k,m) = sqrt((xPos_2(k) - X_2(m))^2 + (yPos_2(k) - Y_2(m))^2);   
                delay_2(k,m)=2*Distance_2(k,m)/speed1 ;
            end
        end
    end
end


%% Realizamos la generacin de las imagenes
disp('-- start Beamforming methods  --'); 
if view_3d==0 
    disp('-- standard 2D Beamforming methods  --'); 

    DAS = zeros(nElements,length(delay));
    DAS_c = zeros(nElements,length(delay));
    DAS_i = zeros(nElements,length(delay));

    DMAS = zeros(nElements,length(delay));
    DMAS_c = zeros(nElements,length(delay));
    DMAS_i = zeros(nElements,length(delay));

    % calculamos DAS, DMAS y CWB metodos
    %Delay-and-Sum method
        for k = vector_plot
            DAS(k,:) = (interp1(time,medida11(k,:),delay(k,:),'spline'));
            DAS_c(k,:) = (interp1(time_c,medida_c(k,:),delay(k,:),'spline'));
            DAS_i(k,:) = (interp1(time_i,medida_i(k,:),delay(k,:),'spline'));
        end

    %Delay-Multiply-and-Sum
        [a, b] = triangulo(nElements);
        for c =1:numel(a)  
            temp=   interp1(time,medida11(a(c),:),delay(a(c),:),'spline').*...
                    interp1(time,medida11(b(c),:),delay(b(c),:),'spline');
            DMAS(a(c),:) = DMAS(a(c),:) + temp;%.* ...

            temp_c=   interp1(time,medida_c(a(c),:),delay(a(c),:),'spline').*...
                    interp1(time,medida_c(b(c),:),delay(b(c),:),'spline');
            DMAS_c(a(c),:) = DMAS_c(a(c),:) + temp_c;%.* ..

            tempi=   interp1(time_i,medida_i(a(c),:),delay(a(c),:),'spline').*...
                    interp1(time_i,medida_i(b(c),:),delay(b(c),:),'spline');
            DMAS_i(a(c),:) = DMAS_i(a(c),:) + tempi;%.* .. 
        end
    % Coherence Weighted Beamformer

    m_DASI=zeros(1,length(DAS));
    s_DASI=zeros(1,length(DAS));
    CF=zeros(1,length(DAS));
    CAS=zeros(1,length(DAS));

    m_DASI_i=zeros(1,length(DAS_i));
    s_DASI_i=zeros(1,length(DAS_i));
    CF_i=zeros(1,length(DAS_i));
    CAS_i=zeros(1,length(DAS_i));

    m_DASI_c=zeros(1,length(DAS_c));
    s_DASI_c=zeros(1,length(DAS_c));
    CF_c=zeros(1,length(DAS_c));
    CAS_c=zeros(1,length(DAS_c));

    for i=1:length(DAS)
        m_DASI(i)=sum((sum(DAS(:,i),1).^2),2);
        s_DASI(i)=sum((sum(DAS(:,i).^2,2)),1);
        CF(i)=m_DASI(i)./s_DASI(i);
        CAS(i)=m_DASI(i).*CF(i);
        
        m_DASI_i(i)=sum((sum(DAS_i(:,i),1).^2),2);
        s_DASI_i(i)=sum((sum(DAS_i(:,i).^2,2)),1);
        CF_i(i)=m_DASI_i(i)./s_DASI_i(i);
        CAS_i(i)=m_DASI_i(i).*CF_i(i);

        m_DASI_c(i)=sum((sum(DAS_c(:,i),1).^2),2);
        s_DASI_c(i)=sum((sum(DAS_c(:,i).^2,2)),1);
        CF_c(i)=m_DASI_c(i)./s_DASI_c(i);
        CAS_c(i)=m_DASI_c(i).*CF_c(i);

    end

    DASI=zeros(1,length(DAS));
    DMASI=zeros(1,length(DMAS));
    CASI=zeros(1,length(DAS));
    DASI_i=zeros(1,length(DAS_i));
    DMASI_i=zeros(1,length(DMAS_i));
    CASI_i=zeros(1,length(DAS_i));

    DASI_c=zeros(1,length(DAS_c));
    DMASI_c=zeros(1,length(DMAS_c));
    CASI_c=zeros(1,length(DAS_c));
    
    for i=1:length(DAS)
        DASI(i)=(sum(DAS(:,i),1)).^2; %Potencia
        DMASI(i)=(sum(DMAS(:,i),1).^2); %potencia
        CASI(i)=(sum(CAS(:,i),1).^2); %potencia
        DASI_i(i)=(sum(DAS_i(:,i),1)).^2; %Potencia
        DMASI_i(i)=(sum(DMAS_i(:,i),1).^2); %potencia
        CASI_i(i)=(sum(CAS_i(:,i),1).^2); %potencia
        DASI_c(i)=(sum(DAS(:,i),1)).^2; %Potencia
        DMASI_c(i)=(sum(DMAS(:,i),1).^2); %potencia
        CASI_c(i)=(sum(CAS(:,i),1).^2); %potencia
    end

    DASI=(DASI/max(DASI)); %Normalizamos los valores
    DMASI=(DMASI/max(DMASI)); %Normalize
    CASI=(CASI/max(CASI)); %Normalize

    DASI_i=(DASI_i/max(DASI_i)); %Normalizamos los valores
    DMASI_i=(DMASI_i/max(DMASI_i)); %Normalize
    CASI_i=(CASI_i/max(CASI_i)); %Normalize

    DASI_c=(DASI_c/max(DASI_c)); %Normalizamos los valores
    DMASI_c=(DMASI_c/max(DMASI_c)); %Normalize
    CASI_c=(CASI_c/max(CASI_c)); %Normalize


    % DASI=DASI;%.^4; % Elevando a la 4 potencia se realza y mucho los picos con respecto al resto. Interesante para mamas y NO para cerebros.
    % DMASI=DMASI;%.^4; %Normalize
    % CASI=CASI;%.^4; %Normalize
else
    if view_3d_level==1 

        disp('-- 3D level Beamforming methods  --'); 

        DAS_1 = zeros(length(level_1),length(delay_1));
        DAS_2 = zeros(length(level_2),length(delay_2));
        DMAS_1 = zeros(length(level_1),length(delay_1));
        DMAS_2 = zeros(length(level_2),length(delay_2));

        % calculamos DAS, DMAS y CWB metodos
        %Delay-and-Sum method
            for k = 1:length(level_1)
                DAS_1(k,:) = (interp1(time,medida11(level_1(k),:),delay_1(k,:),'spline'));
            end
            for k = 1:length(level_2)
                DAS_2(k,:) = (interp1(time,medida11(level_2(k),:),delay_2(k,:),'spline'));
            end
        %Delay-Multiply-and-Sum
            [a, b] = triangulo(length(level_1));
            for c =1:numel(a)  
                temp=   interp1(time,medida11(level_1(a(c)),:),delay_1(a(c),:),'spline').*...
                        interp1(time,medida11(level_1(b(c)),:),delay_1(b(c),:),'spline');
                DMAS_1(a(c),:) = DMAS_1(a(c),:) + temp;%.* ...
            end
            [a, b] = triangulo(length(level_2));
            for c =1:numel(a)  
                temp=   interp1(time,medida11(level_2(a(c)),:),delay_2(a(c),:),'spline').*...
                        interp1(time,medida11(level_2(b(c)),:),delay_2(b(c),:),'spline');
                DMAS_2(a(c),:) = DMAS_2(a(c),:) + temp;%.* ...
            end
        % Coherence Weighted Beamformer

        m_DASI_1=zeros(1,length(DAS_1));
        s_DASI_1=zeros(1,length(DAS_1));
        CF_1=zeros(1,length(DAS_1));
        CAS_1=zeros(1,length(DAS_1));

        m_DASI_2=zeros(1,length(DAS_2));
        s_DASI_2=zeros(1,length(DAS_2));
        CF_2=zeros(1,length(DAS_2));
        CAS_2=zeros(1,length(DAS_2));

        for i=1:length(DAS_1)
            m_DASI_1(i)=sum((sum(DAS_1(:,i),1).^2),2);
            s_DASI_1(i)=sum((sum(DAS_1(:,i).^2,2)),1);
            CF_1(i)=m_DASI_1(i)./s_DASI_1(i);
            CAS_1(i)=m_DASI_1(i).*CF_1(i);
        end

        for i=1:length(DAS_2)
            m_DASI_2(i)=sum((sum(DAS_2(:,i),1).^2),2);
            s_DASI_2(i)=sum((sum(DAS_2(:,i).^2,2)),1);
            CF_2(i)=m_DASI_2(i)./s_DASI_2(i);
            CAS_2(i)=m_DASI_2(i).*CF_2(i);
        end
        DASI_1=zeros(1,length(DAS_1));
        DMASI_1=zeros(1,length(DMAS_1));
        CASI_1=zeros(1,length(DAS_1));
        DASI_2=zeros(1,length(DAS_2));
        DMASI_2=zeros(1,length(DMAS_2));
        CASI_2=zeros(1,length(DAS_2));
    
        for i=1:length(DAS_1)
            DASI_1(i)=(sum(DAS_1(:,i),1)).^2; %Potencia
            DMASI_1(i)=(sum(DMAS_1(:,i),1).^2); %potencia
            CASI_1(i)=(sum(CAS_1(:,i),1).^2); %potencia
        end
        for i=1:length(DAS_2)
            DASI_2(i)=(sum(DAS_2(:,i),1)).^2; %Potencia
            DMASI_2(i)=(sum(DMAS_2(:,i),1).^2); %potencia
            CASI_2(i)=(sum(CAS_2(:,i),1).^2); %potencia
        end

        DASI_1=(DASI_1/max(DASI_1)); %Normalizamos los valores
        DMASI_1=(DMASI_1/max(DMASI_1)); %Normalize
        CASI_1=(CASI_1/max(CASI_1)); %Normalize

        DASI_2=(DASI_2/max(DASI_2)); %Normalizamos los valores
        DMASI_2=(DMASI_2/max(DMASI_2)); %Normalize
        CASI_2=(CASI_2/max(CASI_2)); %Normalize

        % DASI=DASI;%.^4; % Elevando a la 4 potencia se realza y mucho los picos con respecto al resto. Interesante para mamas y NO para cerebros.
        % DMASI=DMASI;%.^4; %Normalize
        % CASI=CASI;%.^4; %Normalize
    else
         disp('-- 3D standard Beamforming methods  --'); 
    end
    
end


%% Creamos las imagenes 
if view_3d==0   
    disp('-- Plot Results  2D --'); 
    offset_image= 0.025; %
    fig1 = figure;
    %fig1.Color = 'w';
    ax = axes('Parent', fig1);
    view([0 90]);
    scatter(ax, xPos, yPos, 'filled');
    axis( [(min(X)-offset_image) (max(X)+offset_image) (min(Y)-offset_image) (max(Y)+offset_image)])
    axis(ax, 'square');
    grid(ax, 'on');
    title(ax, 'Posiciones Antenas')
    xlabel('distance (m)');
    ylabel('distance (m)');
    hold on;
    scatter(X,Y,100,(DASI),'.');
    colorbar;

    figure;
    subplot(3,1,1)
    scatter(X,Y,500,(DASI),'.');
    axis('square')
    grid( 'on')
    axis( [(min(X)-offset_image) (max(X)+offset_image) (min(Y)-offset_image) (max(Y)+offset_image)])
    title('Imagen algoritmo Delay and Sum')
    colorbar;
    xlabel('distance (m)');
    ylabel('distance (m)');
    subplot(3,1,2)
    scatter(X,Y,500,(DMASI),'.');
    title('Imagen algoritmo Delay Multiply and Sum')
    colorbar;
    axis( [(min(X)-offset_image) (max(X)+offset_image) (min(Y)-offset_image) (max(Y)+offset_image)])
    axis('square')
    grid( 'on')
    xlabel('distance (m)');
    ylabel('distance (m)');
    subplot(3,1,3)
    scatter(X,Y,500,(CASI),'.');
    title('Imagen algoritmo Coherence Weighted Beamformer')
    colorbar;
    axis( [(min(X)-offset_image) (max(X)+offset_image) (min(Y)-offset_image) (max(Y)+offset_image)])
    axis('square')
    grid( 'on')
    xlabel('distance (m)');
    ylabel('distance (m)');


    figure;
    subplot(3,1,1)
    scatter(X,Y,500,(DASI_c),'.');
    axis('square')
    grid( 'on')
    axis( [(min(X)-offset_image) (max(X)+offset_image) (min(Y)-offset_image) (max(Y)+offset_image)])
    title('Imagen algoritmo Delay and Sum iCZT')
    colorbar;
    xlabel('distance (m)');
    ylabel('distance (m)');
    subplot(3,1,2)
    scatter(X,Y,500,(DMASI_c),'.');
    title('Imagen algoritmo Delay Multiply and Sum iCZT')
    colorbar;
    axis( [(min(X)-offset_image) (max(X)+offset_image) (min(Y)-offset_image) (max(Y)+offset_image)])
    axis('square')
    grid( 'on')
    xlabel('distance (m)');
    ylabel('distance (m)');
    subplot(3,1,3)
    scatter(X,Y,500,(CASI_c),'.');
    title('Imagen algoritmo Coherence Weighted Beamformer iCZT')
    colorbar;
    axis( [(min(X)-offset_image) (max(X)+offset_image) (min(Y)-offset_image) (max(Y)+offset_image)])
    axis('square')
    grid( 'on')
    xlabel('distance (m)');
    ylabel('distance (m)');

    figure;
    subplot(3,1,1)
    scatter(X,Y,500,(DASI_i),'.');
    axis('square')
    grid( 'on')
    axis( [(min(X)-offset_image) (max(X)+offset_image) (min(Y)-offset_image) (max(Y)+offset_image)])
    title('Imagen algoritmo Delay and Sum interpol')
    colorbar;
    xlabel('distance (m)');
    ylabel('distance (m)');
    subplot(3,1,2)
    scatter(X,Y,500,(DMASI_i),'.');
    title('Imagen algoritmo Delay Multiply and Sum interpol')
    colorbar;
    axis( [(min(X)-offset_image) (max(X)+offset_image) (min(Y)-offset_image) (max(Y)+offset_image)])
    axis('square')
    grid( 'on');
    xlabel('distance (m)');
    ylabel('distance (m)');
    subplot(3,1,3)
    scatter(X,Y,500,(CASI_i),'.');
    title('Imagen algoritmo Coherence Weighted Beamformer interpol')
    colorbar;
    axis( [(min(X)-offset_image) (max(X)+offset_image) (min(Y)-offset_image) (max(Y)+offset_image)])
    axis('square')
    grid( 'on')
    xlabel('distance (m)');
    ylabel('distance (m)');
else
    if view_3d_level==0
        disp('-- Plot Results  3D --');
        figure
        scatter3(points(:, 1).*1000, points(:, 2).*1000, points(:, 3).*1000, '.');
        hold on
        scatter3(xPos.*1000, yPos.*1000, zPos.*1000,100,'filled','r');
        xlabel('distance (mm)');
        ylabel('distance (mm)');
        zlabel('distance (mm)');
        axis vis3d;
    else
        disp('-- Plot Results  3D level --'); 
        offset_image= 0.025; %
        fig1 = figure;
        ax = axes('Parent', fig1);
        view([0 90]);
        scatter3(ax, xPos_1, yPos_1, zPos_1, 'filled');
        axis( [(min(X_1)-offset_image) (max(X_1)+offset_image) (min(Y_1)-offset_image) (max(Y_1)+offset_image) (-offset_image) (max(zPos)+offset_image) ]);
        axis(ax, 'square');
        grid(ax, 'on');
        title(ax, 'Posiciones Antenas')
        xlabel('distance (m)');
        ylabel('distance (m)');
        zlabel('distance (m)');
        hold on;      
        scatter3(ax, xPos_2, yPos_2, zPos_2, 'filled');
        
        Z_1=zeros(1,length(X_1))+max(zPos_1);
        Z_2=zeros(1,length(X_2))+max(zPos_2);

        fig2 = figure;
        bx = axes('Parent', fig2);
        view([0 90]);
        scatter3(bx,X_1,Y_1,Z_1,100,DASI_1,'.');
        colorbar;
        axis( [(min(X_2)-offset_image) (max(X_2)+offset_image) (min(Y_2)-offset_image) (max(Y_2)+offset_image) (-offset_image) (max(zPos)+offset_image) ]);
        axis(bx, 'square');
        grid(bx, 'on');
        title(bx, 'Posiciones Antenas')
        xlabel('distance (m)');
        ylabel('distance (m)');
        zlabel('distance (m)'); 
        hold on;
        scatter3(bx,X_2,Y_2,Z_2,100,DASI_2,'.');
        
        fig3=figure;
        subplot(1,3,1)
        view([0 90]);
        scatter3(X_1,Y_1,Z_1,100,DASI_1,'.');
        colorbar;
        axis( [(min(X_2)-offset_image) (max(X_2)+offset_image) (min(Y_2)-offset_image) (max(Y_2)+offset_image) (-offset_image) (max(zPos)+offset_image) ]);
        axis( 'square');
        grid( 'on');
        title('Imagen algoritmo Delay and Sum')
        xlabel('distance (m)');
        ylabel('distance (m)');
        zlabel('distance (m)'); 
        hold on;
        scatter3(X_2,Y_2,Z_2,100,DASI_2,'.');
        
        subplot(1,3,2)
        view([0 90]);
        scatter3(X_1,Y_1,Z_1,100,DMASI_1,'.');
        colorbar;
        axis( [(min(X_2)-offset_image) (max(X_2)+offset_image) (min(Y_2)-offset_image) (max(Y_2)+offset_image) (-offset_image) (max(zPos)+offset_image) ]);
        axis( 'square');
        grid( 'on');
        title('Imagen algoritmo Delay Multiply and Sum')
        xlabel('distance (m)');
        ylabel('distance (m)');
        zlabel('distance (m)'); 
        hold on;
        scatter3(X_2,Y_2,Z_2,100,DMASI_2,'.');
        
        subplot(1,3,3)
        view([0 90]);
        scatter3(X_1,Y_1,Z_1,100,CASI_1,'.');
        colorbar;
        axis( [(min(X_2)-offset_image) (max(X_2)+offset_image) (min(Y_2)-offset_image) (max(Y_2)+offset_image) (-offset_image) (max(zPos)+offset_image) ]);
        axis('square');
        grid('on');
        title('Imagen algoritmo Coherence Weighted Beamformer')
        xlabel('distance (m)');
        ylabel('distance (m)');
        zlabel('distance (m)'); 
        hold on;
        scatter3(X_2,Y_2,Z_2,100,CASI_2,'.');
    end
end

%% er y ur estimation  
if estimacion == 0
    disp('-- Nicolson-Ross-Weir Algorithm Without HEAD disabled --');
else
    disp('-- Nicolson-Ross-Weir Algorithm Without HEAD enabled--');
    lamda_0=(c_v./f); %Free-space wavelength (m)
    lamda_c=Inf;% lamda_c = Inf for TEM transmission lines such as coaxial lines and free-space
    d=2*espesor;  %sample thickness (in meters)
    for n = 1:size(S11_nc,1)
       for m = 1:size(S11_nc,1) 
       X_nc(n,m)=((S11_nc(n,m).^2-S21_nc(n,m).^2)+1)./(2*S11_nc(n,m));% (1.2) R&S doc
       % Calculate reflection coefficient (gamma) and reject impossible values
       Gamma(n,m)=X_nc(n,m)+sqrt((X_nc(n,m).^2)-1); %(1.1) R&S doc 
       if abs(Gamma(n,m))<=1  % (1.1) R&S doc
           Gamma(n,m)=X_nc(n,m)+sqrt((X_nc(n,m).^2)-1);
       else
           Gamma(n,m)=X_nc(n,m)-sqrt((X_nc(n,m).^2)-1);
       end
            % Calculate transmission and propagation constants
       P(n,m)=((S11_nc(n,m)+S21_nc(n,m)-Gamma(n,m))./(1-((S11_nc(n,m)+S21_nc(n,m)).*Gamma(n,m))));% (1.3) R&S doc               
       phi(n,m)=log(1./P(n,m));
       phi2(n,m) = real(phi(n,m)) + 1i*unwrap(imag(phi(n,m)));  
       n2(n,m) = (f(m).*tg_nc(n,m)) - (unwrap(imag(phi(n,m)))./(2.*pi)); %revisar phi en radianes
            if n2(n,m)>0 
                n_root(n,m) = floor(n2(n,m));
            elseif n2(n)<0  
                n_root(n,m) = abs(ceil(n2(n,m)));
            else
               n_root(n,m) = 0;
            end

        inv_lambda2(n,m) = -(((1/(2*pi*d)).*(phi2(n,m) + 2.*pi.*n_root(n,m).*1i)).^2);
        inv_lambda(n,m) = sqrt(inv_lambda2(n,m));
    
        mu_NRW_nc(n,m)=((1.+Gamma(n,m)).* inv_lambda(n,m))./((1.-Gamma(n,m)).*sqrt((1./lamda_0(m).^2)-(1./lamda_c.^2)));
        eps_NRW_nc(n,m)=(lamda_0(m).^2).*(1./mu_NRW_nc(n,m)).*((1./lamda_c.^2)-inv_lambda2(n,m)); %(1.13 R&S)
        delta1_nc(n,m) = real(mu_NRW_nc(n,m)).*real(eps_NRW_nc(n,m)) - (-imag(mu_NRW_nc(n,m)).*-imag(eps_NRW_nc(n,m)));
        delta2_nc(n,m) = real(mu_NRW_nc(n,m)).*(-imag(eps_NRW_nc(n,m))) + (-imag(mu_NRW_nc(n,m)).*real(eps_NRW_nc(n,m)));
        tand_nc(n,m) = delta2_nc(n,m)./delta1_nc(n,m); % Tan(d) according to W.B. Weir
       end
        disp(strcat(['Epsilon NRW antenna ',num2str(n), ' without HEAD min/max: ',num2str(min(real(eps_NRW_nc(n,:)))),' / ', num2str(max(real(eps_NRW_nc(n,:))))]));
    end
    disp('\****************************************************************/');
    clear Gamma P phi phi2 n2 inv_lambda2 inv_lambda;
    for n = 1:size(S11_c,1)
       for m = 1:size(S11_c,1) 
       X_c(n,m)=((S11_c(n,m).^2-S21_c(n,m).^2)+1)./(2*S11_c(n,m));% (1.2) R&S doc
       % Calculate reflection coefficient (gamma) and reject impossible values
       Gamma(n,m)=X_c(n,m)+sqrt((X_c(n,m).^2)-1); %(1.1) R&S doc 
       if abs(Gamma(n,m))<=1  % (1.1) R&S doc
           Gamma(n,m)=X_c(n,m)+sqrt((X_c(n,m).^2)-1);
       else
           Gamma(n,m)=X_c(n,m)-sqrt((X_c(n,m).^2)-1);
       end
            % Calculate transmission and propagation constants
       P(n,m)=((S11_c(n,m)+S21_c(n,m)-Gamma(n,m))./(1-((S11_c(n,m)+S21_c(n,m)).*Gamma(n,m))));% (1.3) R&S doc               

       phi(n,m)=log(1./P(n,m));
       phi2(n,m) = real(phi(n,m)) + 1i*unwrap(imag(phi(n,m)));  
       n2(n,m) = (f(m).*tg_nc(n,m)) - (unwrap(imag(phi(n,m)))./(2.*pi)); %revisar phi en radianes

            if n2(n,m)>0 
                n_root(n,m) = floor(n2(n,m));
            elseif n2(n)<0  
                n_root(n,m) = abs(ceil(n2(n,m)));
            else
               n_root(n,m) = 0;
            end

        inv_lambda2(n,m) = -(((1/(2*pi*d)).*(phi2(n,m) + 2.*pi.*n_root(n,m).*1i)).^2);
        inv_lambda(n,m) = sqrt(inv_lambda2(n,m));
    
        mu_NRW_c(n,m)=((1.+Gamma(n,m)).* inv_lambda(n,m))./((1.-Gamma(n,m)).*sqrt((1./lamda_0(m).^2)-(1./lamda_c.^2)));
        eps_NRW_c(n,m)=(lamda_0(m).^2).*(1./mu_NRW_c(n,m)).*((1./lamda_c.^2)-inv_lambda2(n,m)); %(1.13 R&S)
        delta1_c(n,m) = real(mu_NRW_c(n,m)).*real(eps_NRW_c(n,m)) - (-imag(mu_NRW_c(n,m)).*-imag(eps_NRW_c(n,m)));
        delta2_c(n,m) = real(mu_NRW_c(n,m)).*(-imag(eps_NRW_c(n,m))) + (-imag(mu_NRW_c(n,m)).*real(eps_NRW_c(n,m)));
        tand_c(n,m) = delta2_c(n,m)./delta1_c(n,m); % Tan(d) according to W.B. Weir
       end
        disp(strcat(['Epsilon NRW antenna ',num2str(n), ' with HEAD min/max: ',num2str(min(real(eps_NRW_c(n,:)))),' / ', num2str(max(real(eps_NRW_c(n,:))))]));
    end
end

%%
function [a, b] = triangulo(n)
  a = zeros(n*(n-1)/2, 1);
  b = zeros(n*(n-1)/2, 1);
  k = 0;
  for i = 1:n,
    for j = i+1:n,
      k = k + 1;
      a(k) = i;
      b(k) = j;
    end
  end
end
